#!/bin/sh
#
# Component: cases
#
# Description:
#
# Usage:
#   checkLockedUsers
#
#
# Last Updated     : $Author$
# Update Date Time : $Date$
# RCS File Name    : $RCSfile$
# RCS Revision     : $Revision$
# Locked by        : $Locker$
# Symbolic name    : $Name$
# State            : $State$
#

. $HOME/etc/setenv.sh

#we have to do it in 2 steps because of the logging :(

echo "checking locked users"
now=`date +%s`
echo "now:"$now
query="select USERID from Access where USERLOCKED='yes' and USERACTUALUNLOCK != 0 and $now>=USERLOCKEDSINCE+USERACTUALUNLOCK*60"
echo $query
res=`echo $query | $MYSQL_HOME/bin/mysql -N $DBNAME`
echo $res
inclause=""
if [ ! -z "$res" ] ; then
	for user in $res ; do
		inclause="${inclause},'$user'"
		#log here with $user
		$LOG_HOME/logintodatabase.sh -p "INFO" -l "ADMIN" -a "userAUTOUNLOCK" -u "system" -m "User ${user} has been auto-unlocked" 
	done
	inclause=${inclause#","}
	echo $inclause
	update1="delete from FailedLogin where FLUSERID in ($inclause)"
	echo $update1
	echo $update1 | $MYSQL_HOME/bin/mysql -N $DBNAME
	
	update2="update Access set USERLOCKED='no' where USERID in ($inclause)"
	echo $update2
	echo $update2 | $MYSQL_HOME/bin/mysql -N $DBNAME
fi
