#!/bin/sh

#
# This script is run only when upgrading very old 
# releases, where Dcreport table did not exist.
#
#


. $HOME/etc/setenv.sh

DEBUG_FILE="$TMP/convertreport.txt"

CWD=`pwd`

Counter=0

for study in `$REPOSITORYHANDLER_HOME/bin/listDirectories $REPOSITORY_DATA_DICOM` ; do
	studydir=`$REPOSITORYHANDLER_HOME/bin/locateResource $REPOSITORY_DATA_DICOM $study`
	cd $studydir 2>/dev/null
	[ $? -ne 0 ] && continue; 
	for ReportFileName in `ls PbR.* 2>/dev/null` ; do
		if [ -f "$ReportFileName" ] ; then
			echo "$Study - $ReportFileName" >> $DEBUG_FILE
			$SR_HOME/convertreport.sh -S $Study -d -f
			res=$?
			if [ $res -ne 0 ] ; then
				echo "FAILED" >> $DEBUG_FILE
			fi
		fi
	done
done

cd $CWD
