<%--
 * Component: cases
 *
 * Description:
 *    Performs daily tasks: purges old studies and orders.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%><%@page import="com.erad.rmisubstitute.param.SPCResult"%>
<%@page import="com.erad.rmisubstitute.call.studybatch.StudiesPropsCollector"%>
<%@page import="com.erad.rmisubstitute.call.studybatch.StudiesPropsCollector.PROPTYPES"%>
<%@page import="imagemed.http.rmi.RMISubstitute"%>
<%@page import="com.erad.pacs.modules.gwt.descriptors.akac.LockDescriptor"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.SessionException"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@
	page import="java.util.*,java.io.*,imagemed.imsession.*,imagemed.dotcom.*,imagemed.util.*,imagemed.jsputil.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	Helper.DEBUG( "activitysign.jsp call from " + request.getRemoteAddr() );

	Session is = null;
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	try {
		is = userManager.getSessitaSessionNoSessParCheck( request, response );
		if ( request.getParameter( "r_no_refresh" ) == null )
			userManager.updateLastSeen( is.getSessionId() );
	}
	catch ( SessionException se ) {
		response.setHeader( "IMAuthenticationInfo", "nosession" );
		return;
	}

	//IMSession is = new IMSession( request, response, out );//7.3
	String strViewSessionID = request.getParameter( "ViewSessionID" );
	//is.bRegNotNeeded = request.getParameter( "r_no_refresh" ) != null;//7.3
	boolean bRegNotNeeded = request.getParameter( "r_no_refresh" ) != null;

	boolean touchOnly = request.getParameter( "TouchOnly" ) != null;
	
	String regIP = null;
	if ( touchOnly ) {
		//is.regIP = request.getParameter( "IP" );//7.3
		regIP = request.getParameter( "IP" );
	}

	//if ( !is.regOK() ) {//7.3
	//	return;
	//}

	response.setContentType( "text/plain" );
	response.setHeader( "Pragma", "no-cache" );

	// Keeping login alive from child server after redirecting getpbs
	if ( touchOnly ) {
		out.println( "true" );
		return;
	}

	// Check if login should be kept alive on the parent server (redirected getpbs)
	//if ( !is.bRegNotNeeded ) {//7.3
	if ( !bRegNotNeeded ) {
		try {
			//if ( is.isParentSession ) {//7.3
			if ( userManager.isSessionRemote( is.getSessionId() ) ) {
				String parentId = DotcomConfig.selfParent();
				if ( parentId != null ) {
					//Dotcom.proxyURL( is, parentId, "/cases/activitysign.jsp?TouchOnly=true&IP=" + is.regIP, false, false );
					Dotcom.proxyURL( is, parentId, "/cases/activitysign.jsp?TouchOnly=true&IP=" + regIP, false, false );
				}
			}
		}
		catch ( Throwable th ) {
		}
	}

	// collect needed properties ahead in one pass
	HashMap<PROPTYPES, HashSet<String>> studiesToQuery = new HashMap<PROPTYPES, HashSet<String>>();
	String strVidFileName = IMEnvBase.getEnv( "LOGIN_TMP" ) + "/" + strViewSessionID + ".vid";
	File fVidFile = new File( strVidFileName );
	HashMap<String, FingerPrint> vidFingerprints = null;
	if ( fVidFile.exists() ) {
		vidFingerprints = VIDManager.readStudyFingerprintsFromVID( strViewSessionID );
		HashSet<String> studies = new HashSet<String>();
		studies.addAll( vidFingerprints.keySet() );
		studiesToQuery.put( PROPTYPES.FINGERPRINT, studies );
		studiesToQuery.put( PROPTYPES.LOCKSTATE, studies );
	}
	try {
		studiesToQuery.putAll( ViewSessionProps.getStudyPropsToCollect( is, strViewSessionID ) );
	}
	catch ( Exception e ) {
		Helper.ERRORLOG( Helper.toString( e ) );
	}

	SPCResult scpRes = new StudiesPropsCollector(studiesToQuery).run( RMISubstitute.createContext( is ) );
	StringBuilder strChanged = new StringBuilder();

	if ( fVidFile.exists() ) {
		Helper.DEBUG( "vidfile exists:" + strVidFileName );

		vidFingerprints = VIDManager.readStudyFingerprintsFromVID( strViewSessionID );
		HashMap<String, FingerPrint> curFingerprints = new HashMap<String, FingerPrint>();
		for (String s : scpRes.m_fingerPrintMap.keySet() ) {
			curFingerprints.put( s, FingerPrint.fromRmi( scpRes.m_fingerPrintMap.get( s ) ) );
		}
		//VIDManager.rmiGetFingerPrints( null, new Vector<String>( vidFingerprints.keySet() ) );

		//LockStatManager lsm = (LockStatManager) studiesPropsMap.get( PROPTYPES.LOCKSTATE );//7.3
		//HashMap<String, LockDescriptor> lsm = (HashMap<String, LockDescriptor>) studiesPropsMap.get( PROPTYPES.LOCKSTATE );

		for ( String study : vidFingerprints.keySet() ) {
			//if ( is.regID != null ) {//7.3
			if ( is.getUser().getUserId() != null ) {
				//Properties lockPrp = new Properties();
				//IMLock.lockStudy( is, study, "CheckLock", lockPrp );
				//String lockOwner = lockPrp.getProperty( "IMLockOwner" );
				//String lockOwnerID = lsm.getLockOwner( study );//7.3
				String lockOwnerID = scpRes.m_lockDescriptorMap.get( study ).getLockOwner();
				//lockPrp.getProperty( "IMLockerID" );
				//if ( !is.regID.equals( lockOwnerID ) ) {//7.3
				if ( !is.getUser().getUserId().equals( lockOwnerID ) ) {
					String lockOwner = Helper.getUserName( is, lockOwnerID );

					Helper.DEBUG( "activitysign.jsp", "lostlock: LostLock:" + study + " -> " + ( lockOwner == null ? "" : lockOwner ) );
					response.addHeader( "LostLock:" + study, lockOwner );
				}
			}

			FingerPrint vidFP = vidFingerprints.get( study );
			FingerPrint curFP = curFingerprints.get( study );

			if ( vidFP != null && curFP != null ) {
				Helper.DEBUG( "activitysign.jsp", "Comparing vid files for study " + study );
				Vector<String> changedObjects = curFP.getChangedList( vidFP );
				if ( changedObjects != null ) {
					for ( String obj : changedObjects ) {
						Helper.DEBUG( "activitysign.jsp", obj + " has changed for study " + study );
						strChanged.append( obj ).append( ";" );
					}
				}
			}
			else if ( vidFP == null ) {
				Helper.DEBUG( "activitysign.jsp", "Fingerprint in vid file is null or not yet updated for study " + study );
			}
			else {
				Helper.DEBUG( "activitysign.jsp", "Current fingerprint is null or could not be collected for study " + study );
			}
		}
	}

	ViewSessionProps.printViewSessionChanges( is, strViewSessionID, scpRes.m_studyStateMap );

	//out.println( "# SessionID: " + is.regCookie );//7.3
	out.println( "# SessionID: " + is.getSessionId() );
	out.println( "# ViewSessionID: " + strViewSessionID );
	out.println( "# Viewer: " + ( bRegNotNeeded ? "Idle" : "Active" ) );
	if ( strChanged.length() > 0 ) {
		out.println( "# Changed: " + strChanged.toString() );
	}

	if ( true ) {
		// For avoiding extra new lines
		return;
	}
%>
