<%--
 * Component: cases
 *
 * Description:
 *    Returns the content of the printer config file for the viewer.
 *
 * Last Updated     : $Author$
 * Update Date Time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
--%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>

<%@ page trimDirectiveWhitespaces="true" %>
<%@
	page import="imagemed.http.tabs.TabBean, imagemed.imsession.*, java.io.*"

%><%
	response.setContentType("text/html");
	response.setStatus(200); //must be 200 even on error, whith the earlier
	//403 pb viewer popped up an error message box

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSessionNoSessParCheck( request, response );
	
	TabBean tabbean = new TabBean();

	try {
		TabBean.checkLicense(false);
		int flags = tabbean.getFlags();

		if ((flags & 16) == 16) {
			String custom = IMEnvBase.getEnv("DCMTK_VAR")  + "/printer.cfg";
			String def = IMEnvBase.getEnv("CASES_HOME") + "/printer.cfg";

			File cfg = new File(custom);
			if (cfg == null || !cfg.exists())
				cfg = new File(def);
			
			if (cfg != null && cfg.exists()) {
				response.setContentLength((int) cfg.length());

				FileReader reader = new FileReader(cfg);
				if (reader != null) {
					char[] c = new char[1024];
					int r;
					while ((r = reader.read(c, 0, 1024)) > 0) {
						out.write(c, 0, r);
					}
					reader.close();
				}
			}
			else {
				out.println("file not found: printer.cfg");
			}
		}
		else { 
			out.println("dicom print is not licensed on this server");
		}
	}
	catch(Throwable th) {
		out.println(th.toString());
	}

	if (true) {
		// For avoiding extra new line
		return;
	}
%>
