<%@page import="com.erad.pacs.modules.gwt.exception.usermanager.IMRedirectedException"%>
<%@page import="com.erad.pacs.common.interfaces.result.WorklistResult"%>
<%@page import="com.erad.pacs.toolbox.MahagoniToolbox"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.common.libs.RequestInfo"%>
<%@page import="com.erad.pacs.common.interfaces.list.ListDescriptor"%>
<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.app.broker.table.TableBrokerFacade"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@
  page errorPage ="../main/exceptionHandler.jsp"
%><%@
  page import="imagemed.http.tabs.*, imagemed.imsession.*,imagemed.layout.datasource.*,imagemed.layout.*,imagemed.layout.cache.LayoutCache,
  imagemed.jsputil.*, imagemed.util.LocalizedMessage, imagemed.util.JSHelper, imagemed.util.OperLogEntry, imagemed.util.Syslog,
  imagemed.layout.TimeLine.TlCellDesc,java.util.Map,imagemed.util.Helper"
%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess;
	try {
		sess = userManager.getSessitaSession( request, response );
	}
	catch (IMRedirectedException re) {
		return;
	}
	RequestInfo requestInfo = new RequestInfo(request);
	
  boolean isIntegrated = "true".equals(request.getParameter("cIntegrated"));

  String baseStudy = request.getParameter("cStudy");
  if (baseStudy == null || baseStudy.length() == 0) {
  	throw new imagemed.exception.IMException("A base study must be specified.");
  }
  JspSession js = new JspSession(sess, request);
	LayoutRoot root = LayoutCache.getSystemLayout( js, LayoutPart.PATIENTFOLDERLAYOUT);
	boolean isRefreshing = "true".equals(request.getParameter( "cRefresh" ) );
	
	TableBrokerFacade tb = Connector.getInstance().get( TableBrokerFacade.Caller );
	ListDescriptor listDescriptor = tb.getListDescriptor();
	
 	PatientFolderDataSource dataSource = new PatientFolderDataSource( sess, listDescriptor, baseStudy, false ); // isRefreshing 
 	// initially the datasource is localOnly (will be global is the base study is not local)
 	if (isRefreshing) {
 		try {
 			TimeLine tl = (TimeLine) root.getDescendant( request.getParameter( "tlID" ) );
 			Map<String, TlCellDesc> cellMap = tl.getCells( js, dataSource );
 			out.print( JSHelper.toJSON( cellMap ) );
 			String vsId = MahagoniToolbox.getCookie( request.getCookies(), "ViewSessionID" );
			if (vsId != null && vsId.length( ) > 0){
				ViewSessionProps vsp = ViewSessionProps.readVSP( vsId );
				vsp.setStudyMain( sess, baseStudy );
				vsp.fillStudyStatesMap( sess, baseStudy, true );
				vsp.saveVSP();
				// update viewSession data for this PF
			}
 		}
 		catch (Throwable th) {
 			out.print( JSHelper.toJSON( "Updating failed: " + Helper.toString( th ) ) );
 		}
 		return;
 	}
	root.setStretching( true );
 	dataSource.setToBase( sess ); // position to the base study
  OperatingMode mode = LayoutPart.VIEWING;


	OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.STUDY, "patientfolder" );
	logEntry.setField( OperLogEntry.FIELD.USER, sess.getUser().getUserId() );
	logEntry.setField( OperLogEntry.FIELD.STUDY, baseStudy );
	logEntry.setField( OperLogEntry.FIELD.PNAME, dataSource.getValue( sess, "PANM" ) );
	logEntry.setField( OperLogEntry.FIELD.MODALITY, dataSource.getValue( sess, "MODY" ) );
	logEntry.setField( OperLogEntry.FIELD.STUDYDATE, dataSource.getValue( sess, "DATE" ) );
	logEntry.log( sess, "cases_patientFolder", 0, Syslog.LOG_INFO );
%>
<meta http-equiv="X-UA-Compatible" content="IE=EmulateIE9" />
<html>
<head>
<title>Patient folder of <%=imagemed.types.IMType.getTypeFor( "PN" ).displayText( sess, dataSource.getValue( sess, "PANM" ) )%></title>
<%TabBean.writeStyleOnly( response.getWriter() );
out.println( StyleToolbox.getStylePart( "IMTimeLine" ) );
out.println( StyleToolbox.getStylePart( "PatientFolder" ) );
JSHelper.printJsInclude( out, JSHelper.PATIENTFOLDERSCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.LAYOUTSCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.IMPOPUP_JS );
JSHelper.printJsInclude( out, JSHelper.TABLESCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.TIMELINESCRIPTS_JS );
JSHelper.printJsInclude( out, JSHelper.IMTIMELINESCRIPTS_JS ); 
JSHelper.printJsInclude( out, JSHelper.IMIFRAME_JS );
JSHelper.printJsInclude( out, JSHelper.JQUERY_JS );
%>
<script language=javascript>
	ButtonTitles[ "ViewerOpenButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_ADD_STUDY" )%>";
	ButtonTitles[ "OpenButton" ] = "<%=LocalizedMessage.getSimpleMessage( "BUTTON_OPEN_TITLE" )%>";
	ButtonTitles[ "RetrieveButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_RETRIEVE_STUDY" )%>";
	ButtonTitles[ "QVButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_QV_STUDY" )%>";
	ButtonTitles[ "BackButton" ] = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_BACK" )%>";
	
<%
	String vsId = request.getParameter("ViewSessionID");
	if (vsId != null && vsId.length( ) > 0 ) {
		Cookie coo = new Cookie( "ViewSessionID", vsId );
		coo.setPath( "/" );
		response.addCookie( coo );
%>
var ViewSessionID = "<%=vsId%>";
<%}%>
window.onbeforeunload = function(e) {
	if ( !checkUnsavedNotes( timeLine ) ) {
		return;
	}
  e = e || window.event;

	var res = "<%=LocalizedMessage.getSimpleMessage( "PATIENTFOLDER_UNSAVED_NOTE" )%>";
  
  // For IE and Firefox prior to version 4
  if (e) {
    e.returnValue = res;
  }

  // For Safari
	return res 
};

</script>
</head>
<body class="stretchedToMargin<%=isIntegrated?" dark tight":""%>">
<table cellspacing=0 cellpadding=0 width=100% height=100%>
<%if (!isIntegrated) { %>
<tr><td>
<%
TabToolbox.makeTabs(sess, null, "cases/index.jsp", "White");
%>
</td></tr>
<%
} 
else if (vsId != null && vsId.length( ) > 0){
	ViewSessionProps vsp = ViewSessionProps.readVSP( vsId );
	vsp.fillStudyStatesMap( sess, baseStudy, true );
	vsp.saveVSP();
	// update viewSession data for this PF
}%>
<tr height=100%><td>
<%=root.getHtml( js, "", mode, dataSource )%>
</td></tr></table></body></html>