<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 * Component: cases
 *
 * Description:
 *  WEB interface for deleting study series
 *
 *  @param cStudy        Study Instance UID
 *  @param cSeries       Series Instance UID
 *	@param cSumObj		 Number of objects in Study
 *  @param cBack         URL to go back after editing  (goes back to Referer if missing)
 *  @param cBreak        The study is locked, break the lock
 *  @param cOp           Only accepted value is 'Delete' = delete series
 *
 * Last Updated     : $Author$
 * Update date/time : $Date$
 * RCS File Name    : $RCSfile$
 * RCS Revision     : $Revision$
 * Locked by        : $Locker$
 * Symbolic name    : $Name$
 * State            : $State$
 *
-- %><%@page import="imagemed.types.string.IMTypePN"%>
<%@
	page import="java.util.*, java.io.*, java.sql.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*,
			imagemed.tables.*, imagemed.imtables.*, imagemed.exception.*, imagemed.dcprocessing.*, imagemed.dicom.*,
			imagemed.dotcom.DotcomConfig, imagemed.types.flag.IMTypeur, java.text.Format"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	IMSession is = new IMSession( request, response, out );
	String parStudy = request.getParameter( "cStudy" );
	String parSeries = request.getParameter( "cSeries" );
	String parSumObj = request.getParameter( "cSumObj" );
	String parBack = request.getParameter( "cBack" );
	String parBreak = request.getParameter( "cBreak" );

	String parUser = null;
	
	String deleteError = LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DELETE_ERROR_TITLE" );

	boolean isDelete = "Delete".equals( request.getParameter( "cOp" ) );
	boolean isCancel = "Cancel".equals( request.getParameter( "cOp" ) );

	Syslog slog = new Syslog( "seriesDelete.jsp", 0, IMEnvBase.getEnv( "LOG_OPER_FACILITY" ) );
	Connection IMDB = IMEnv.getDB();
	String pageName = "/cases/seriesDelete.jsp";

	is.regDest = "/cases/index.jsp";
	if ( !is.regOK() ) {
		return;
	}

	String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
	if ( redirHost != null ) {
		String redirURL = redirHost + "/cases/seriesDelete.jsp?" + RedirectToolbox.getRedirectParams( is );
		response.sendRedirect( redirURL );
		return;
	}
	
	Defs casesDefs = new Defs( is, parUser );

%><%!

	static imagemed.types.IMType dispType = new imagemed.types.IMType();
	static imagemed.types.date.IMTypeDA_TM dispDATM = new imagemed.types.date.IMTypeDA_TM();
	static imagemed.types.string.IMTypeiS dispiS = new imagemed.types.string.IMTypeiS();

%><%
	boolean hasDeleteRight = is.hasRight( IMTypeur.DELETE_RIGHT );

	if ( null == parBack )
		parBack = request.getHeader( "Referer" );

	if ( null == parBack )
		parBack = "javascript:self.history.back();";

	// Check if the user has rights to delete study series
	if ( !hasDeleteRight ) {
		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.SERIES, "delete" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );
		logEntry.setField( OperLogEntry.FIELD.FNAME, parSeries );
		logEntry.setField( OperLogEntry.FIELD.MESSAGE, "no rights" );
		logEntry.log( slog, Syslog.LOG_ERR );

		//		slog.syslog(Syslog.LOG_ERR, "ERROR SERIES delete " + casesDefs.getUser() + " " + parSeries + " " + parStudy + " - - - - - - - - - - no_rights");
		Format[] msgFormat = new Format[] { null };
		Object[] msgObject = new Object[] { is.regID };
		throw new IMGeneralException( is,
		LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_SERIESDELETE_NO_RIGHTS", msgFormat, msgObject, true),
		"cases/index.jsp", deleteError, parBack );
		//throw new IMGeneralException( is,
		//		"Sorry " + is.regID + ", you don't have the access rights to delete series.",
		//		"cases/index.jsp", deleteError, parBack );
	}

	int nWaitTime = 30000; // 30 sec

	String SQLtables[] = { "Dcstudy", "Dcobject" };
	IMFieldManager fm = new IMFieldManager( "Dcfields", "Dctypes", SQLtables );

	TableDescriptor tdesc = new TableDescriptor();
	WorklistTableParams tparams = new WorklistTableParams( is.imRequest, casesDefs.getFilterUser() );
	tparams.setDefaults( "/cases/index.jsp", is );

	Properties filters = new Properties();
	filters.setProperty( "SYUI", parStudy );
	tparams.setFilters( filters );

	tdesc.setTableParams( tparams );
	tdesc.setFieldManager( fm );

	WorklistResult result = new WorklistResult( is, tdesc );
	result.setGlobal( true );
	if ( !result.next() || !result.isInAccessList( parStudy ) )
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_NO_SUCH_STUDY" ), "cases/index.jsp", deleteError, parBack );

	String seriesQuery = "select MIN(OMODALITY) as SMODY,  MIN(SERNUMBER) as SN, MIN(concat(SERDATE, '_', SERTIME)) as SDT," +
	" MAX(SERDESCR) as SDESCR, count(*) as SCOUNT, SUM(NOOFFRAMES) as SFRAMES from " + IMEnvBase.getEnv( "OBJECTTBL" ) +
	" where STYIUID='" + parStudy + "' AND SERIUID='" + parSeries + "'";

	ResultSet rsSeries = IMDB.prepareStatement( seriesQuery ).executeQuery();
	if ( !rsSeries.next() )
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_SERIESDELETE_NO_SUCH_SERIES" ), "cases/index.jsp", deleteError, parBack );

	String serNumber = rsSeries.getString( "SN" );
	String serModality = rsSeries.getString( "SMODY" );
	String serDateTime = rsSeries.getString( "SDT" );
	String serDescr = rsSeries.getString( "SDESCR" );
	int serObjs = rsSeries.getInt( "SCOUNT" );
	int serFrames = rsSeries.getInt( "SFRAMES" );

	rsSeries.close();

	if( serObjs == 0 ) {
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_SERIESDELETE_NO_SUCH_SERIES" ), "cases/index.jsp", deleteError, parBack );
	}

	String patientName = IMTypePN.displayOrdinaryText( result.getValue( "PANM" ) );
	String studyDate = result.getValue( "SYDT" );

	// Handle cancel

	if ( isCancel ) {
		IMLock.lockStudy( is, parStudy, "Unlock", new Properties() );
		response.sendRedirect( parBack );
		return;
	}

	/********************
	 *   Delete series  *
	 ********************/

	String lockID = null;
	boolean isDeleted = false;
	MessageBox messageBox = null;
	if ( isDelete ) {
		Properties prpLock = new Properties();
		IMLock.lockStudy( is, parStudy, "CheckLock", prpLock );
		if ( !"OK".equals( prpLock.getProperty( "IMLock" ) ) ) {
			String lockerName = prpLock.getProperty( "IMLockOwner" );
			String lockerMsg = "";
			String msg = "";
			if ( null != lockerName ) {
				Format[] msgFormat = new Format[] { null };
				Object[] msgObject = new Object[] { IMTypePN.displayOrdinaryText( lockerName ) };
				msg = LocalizedMessage.getCompoundMessage( "EXCEPTION_CASES_SERIESDELETE_STUDY_LOCK_LOST_LOCKED_BY", msgFormat, msgObject, true);
			}
			else {
				msg = LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_SERIESDELETE_STUDY_LOCK_LOST" );
			}
			throw new IMGeneralException( is, msg, "cases/index.jsp", deleteError, null );
		}

		if( parSumObj != null && !(parSumObj.equals( "" )) && !(parSumObj.equals( "-1" )) ){
			int intSumObj;
			try{
				intSumObj = Integer.parseInt( parSumObj );
			}
			catch( NumberFormatException nfe ){
				IMLock.lockStudy( is, parStudy, "Unlock", prpLock );
				Helper.ERRORLOG( "seriesDelete", "EXCEPTION: " + Helper.throwable2String( nfe ) );
				throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_SERIESDELETE_ERROR_DELETE" ), "cases/index.jsp", deleteError, parBack );
				
			}
			if ( (intSumObj - serObjs) <= 0 ) {
				IMLock.lockStudy( is, parStudy, "Unlock", prpLock );
				Helper.DEBUG( "seriesDelete", "Unable to delete the last objects in study." );
				throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_SERIESDELETE_ERROR_DELETE_LAST_OBJECTS" ), "cases/index.jsp", deleteError, parBack );
			}
		}
		else {
			IMLock.lockStudy( is, parStudy, "Unlock", prpLock );
			Helper.ERRORLOG( "seriesDelete", "The parSumObj variable's value is " + ((parSumObj == null)? "null" :  parSumObj) );
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_SERIESDELETE_ERROR_DELETE" ), "cases/index.jsp", deleteError, parBack );
		}

		if ( !StudyRemover.invalidateSeries( null, parStudy, null, is.regID, parSeries  ) ) {
			IMLock.lockStudy( is, parStudy, "Unlock", prpLock );
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_SERIESDELETE_ERROR_DELETE" ), "cases/index.jsp", deleteError, parBack );
		}

		String logStudy = Helper.replace( parStudy, " ", "_" );
		String logSeries = Helper.replace( parSeries, " ", "_" );

		OperLogEntry logEntry = new OperLogEntry( OperLogEntry.LEVEL.SERIES, "delete" );
		logEntry.setField( OperLogEntry.FIELD.USER, casesDefs.getUser() );
		logEntry.setField( OperLogEntry.FIELD.STUDY, parStudy );
		logEntry.setField( OperLogEntry.FIELD.FNAME, parSeries );
		logEntry.setField( OperLogEntry.FIELD.PNAME, patientName );
		logEntry.setField( OperLogEntry.FIELD.MODALITY, serModality );
		logEntry.log( slog, Syslog.LOG_INFO );

		logEntry.setLevel( OperLogEntry.LEVEL.STUDY );
		logEntry.setField( OperLogEntry.FIELD.FNAME, "" );
		logEntry.setField( OperLogEntry.FIELD.PARTIAL, "series[1]" );
		logEntry.setField( OperLogEntry.FIELD.STUDYDATE, studyDate );
		logEntry.log( slog, Syslog.LOG_INFO );

		//		slog.syslog(Syslog.LOG_ERR, "INFO SERIES delete " + casesDefs.getUser() + " " + logSeries + " " + logStudy + " " + logPatient+ " " + logModality + " - - - - - - - - -");
		//		slog.syslog(Syslog.LOG_ERR, "INFO STUDY delete " + casesDefs.getUser() + " - " + logStudy + " " + logPatient+ " " + logModality + " - - - - - series[1] - - - - " + logStudyDate );

		IMLock.lockStudy( is, parStudy, "Unlock", prpLock );
		isDeleted = true;
	} // End Delete
	else {
		// Confirmation page, lock the study and check if study is editable

		// Check if all of the objects in the study can be edited (storelevel is not 'Staged')
		EditToolbox.isStudyEditable( is, parStudy, patientName, parBack ); // Will throw an exception if study is uneditable

		Properties prpLock = new Properties();

		String lockAction = ( parBreak != null ) ? "Break" : "Lock";
		IMLock.lockStudy( is, parStudy, lockAction, prpLock );
		if ( !"OK".equals( prpLock.getProperty( "IMLock" ) ) ) {
			String lockerName = prpLock.getProperty( "IMLockOwner" );
			String lockAge = prpLock.getProperty( "IMLockAge" );
			lockerName = ( null == lockerName ) ? LocalizedMessage.getSimpleMessage( "GENERIC_ANOTHER_USER" ) : IMTypePN.displayOrdinaryText( lockerName );

			messageBox = new MessageBox( LocalizedMessage.getSimpleMessage( "GENERIC_LOCKED" ), "60%" );

			Format[] msgFormat = new Format[] { null, null };
			Object[] msgObject = new Object[] { lockerName, ReportToolbox.getLockAgeMessage( lockAge ) };

			String lockMessage;
			if ( is.hasRight( IMTypeur.BREAK_LOCK_RIGHT ) ) {
				lockMessage = "STUDY_LOCK_LOCKED_BY";
			}
			else {
				lockMessage = "STUDY_LOCK_LOCKED_BY_NO_BREAK";
			}

			String msg = LocalizedMessage.getCompoundMessage( lockMessage, msgFormat, msgObject, true);

			messageBox.setMessage( "<H2><BR>" + msg + "<BR><BR></H2>" );

			if ( is.hasRight( IMTypeur.BREAK_LOCK_RIGHT ) ) {
				messageBox.addButton( new Button( "javascript:doSubmit(self.document.breakForm);", "BUTTON_BREAK", "BUTTON_BREAK_TITLE" ) );
			}
			messageBox.addButton( new Button( parBack, "BUTTON_CANCEL", "BUTTON_CANCEL" ) );
		}
		else {
			lockID = prpLock.getProperty( "IMLockID" );
		}
	}
%><HTML>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "CASES_SERIESDELETE_DELETE_SERIES" ) %></title>
<%

	if ( lockID == null )
		lockID = IMLock.getLockIDFromIS( is );

	if ( isDelete ) {
%><META http-equiv="Refresh" content="3; URL=<%=parBack%>"><%
	}

	TabToolbox.writeIMpopup( is.out );
%>
<SCRIPT language="JavaScript">

	var needUnlock = <%=isDeleted ? 0 : 1%>; // in default unlock study when leaving page

	function unlockStudy() {
		if (needUnlock) {
			jsPopup('unlockwindow.jsp?study=<%=parStudy%>&cIMLockID=<%=lockID%>', 'unlockwindow');
		}
	}

	// used to submit delete confirmation form
	function submitDelete(frm, oper) {
		needUnlock = 0;  // in case of save study should not be unlocked
		frm.cOp.value = oper;
		frm.submit();
	}

	// used to submit break lock form
	function doSubmit(frm) {
		needUnlock = 0;  // in case of save study should not be unlocked
		frm.submit();
	}

</SCRIPT>
<%
	Table.printCommonScript( is );
%>
</head>

<BODY onUnload='unlockStudy()'>
<CENTER>
<%
	String tab = "cases/index.jsp";

	TabToolbox.makeTabs( is, is.tabbean, tab, "White" );

	if ( messageBox != null ) {
%>
  <BR>
  <FORM action="<%=pageName%>" method=get name="breakForm">
<%
		messageBox.print( is.out );
		if ( lockID != null ) {
%>
  <INPUT type="hidden" name="cIMLockID" value="<%=lockID%>">
<%
		}
		
		String referringHost = RedirectToolbox.getReferringHost( is );
		if ( referringHost != null && referringHost.length() > 0 ) {
%>
  <INPUT type="hidden" name="RefererHost" value="<%=referringHost%>">
<%
		}
		if ( is.isParentSession ) {
%>
  <INPUT type="hidden" name="ParentSession" value="<%=is._sid.substring( 1 )%>">
<%
		}
%>
  <INPUT type="hidden" name="cStudy" value="<%=parStudy%>">
  <INPUT type="hidden" name="cSeries" value="<%=parSeries%>">
  <INPUT type="hidden" name="cSumObj" value="<%=parSumObj%>">
  <INPUT type="hidden" name="cBack" value="<%=Helper.htmlEncode( parBack )%>">
  <INPUT type="hidden" name="cBreak" value="true">
  </FORM>
</center></body></html>
<%
		return;
	}
%>
  <TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
  <FORM method="post" name="deleteForm" action="seriesDelete.jsp">
  <TR><TD class=BgShadow width="100%">
  <TABLE border=0 cellpadding=0 cellspacing=0 width="100%"><TR>
  <TD class=BgShadow width="50%">
  <BR><font size=4>&nbsp;&nbsp;
  <%
  	// Delete series of PatientName
  	Format[] msgFormat = new Format[] { null };
  	Object[] msgObject = new Object[] { patientName };
  	out.print( LocalizedMessage.getCompoundMessage( "CASES_SERIESDELETE_DELETE_SERIES_OF", msgFormat, msgObject, true) );
  %>
  </font><BR><BR>
  </TD>
  <TD class=BgShadow width="50%" align=right>
  &nbsp;
  </TD>
  </TR></TABLE></TD></TR>
  </TABLE>
  <TABLE border=1 class=BgShadow cellpadding=0 cellspacing=0 width="100%"><TR class=HeaderRow>
<%
	out.println( Helper.headerCell3D( fm.getHeaderName( "SRNM" ), "center", "10%", 1 ) );
	out.println( Helper.headerCell3D( fm.getHeaderName( "MODA" ), "center", "8%", 1 ) );
	out.println( Helper.headerCell3D( fm.getHeaderName( "SRDT" ), "center", "20%", 1 ) );
	out.println( Helper.headerCell3D( fm.getHeaderName( "SRDS" ), "center", null, 1 ) );
	out.println( Helper.headerCell3D( fm.getHeaderName( "NOBJ" ), "center", "8%", 1 ) );
	out.println( Helper.headerCell3D( fm.getHeaderName( "NIMG" ), "center", "8%", 1 ) );
%>
	</TR><TR>
	<TD width="10%"><%=dispiS.display( serNumber )%>&nbsp;</TD>
	<TD width="7%"><%=dispType.display( serModality )%>&nbsp;</TD>
	<TD width="20%"><%=dispDATM.display( serDateTime )%>&nbsp;</TD>
	<TD><%=dispType.display( serDescr )%>&nbsp;</TD>
	<TD width=\"7%\"><%=serObjs%></TD>
	<TD width=\"7%\"><%=serFrames%></TD>
	</TR>
<%
	if ( !isDeleted ) {
%>
  <TR>
   <TD class=BgShadow nowrap colspan=6 align=right>
   <BR>
   <table border=0 width="100%"><tr><td align=left>&nbsp; &nbsp; &nbsp; &nbsp;
    </td><td nowrap align=right>
<%
		Button deleteButton = new Button( "javascript:submitDelete(self.document.deleteForm, 'Delete');","BUTTON_DELETE", "BUTTON_DELETE" );
		deleteButton.print( is.out );
%>&nbsp; &nbsp; &nbsp; &nbsp;<%
 		Button cancelButton = new Button( "javascript:submitDelete(self.document.deleteForm,'Cancel');","BUTTON_CANCEL", "BUTTON_CANCEL" );
 		cancelButton.print( is.out );
 %>
  &nbsp; &nbsp; &nbsp; &nbsp;
    </TD></TR></TABLE>
   </TD>
  </TR>
<%
	}
%>	
	
 <TR>
   <TD colspan=6 class=FieldBlock></td>
 </tr></TABLE>
 <BR>
<%
	if ( isDeleted ) {
		messageBox = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_SERIESDELETE_SERIES_DELETED" ), "60%" );
		messageBox.setMessage( "<H2><BR>" + LocalizedMessage.getSimpleMessage( "CASES_SERIESDELETE_SERIES_DELETED_MSG" ) + "<BR><BR></H2>" );

		messageBox.addButton( new Button( parBack, "BUTTON_BACK", "ALT_TEXT_BACK" ) );
		messageBox.print( is.out );
	}
%>
<%-- <pre><%= result.getDebug() %></pre> -- %>
<input type=hidden name="cOp" value="">
<input type=hidden name=cIMLockID value="<%=Helper.htmlEncode( lockID )%>">
<input type=hidden name=cStudy value="<%=Helper.htmlEncode( parStudy )%>">
<input type=hidden name=cSeries value="<%=Helper.htmlEncode( parSeries )%>">
<input type=hidden name=cSumObj value="<%=parSumObj%>">
<input type=hidden name=cBack value="<%=Helper.htmlEncode( parBack )%>">
</form>
</body>
</html>--%>