<%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@page import="java.util.Enumeration"%>
<%@page import="java.util.Properties"%>
<%@page import="java.util.ArrayList"%>
<%@page import="java.util.List"%>
<%@page import="imagemed.dotcom.DotcomConfig"%><%--
* Component: cases
*
* Description:
*  Interface for uploading a study (to the given HUB), extracting it and importing to the worklist
*
* Parameters (multipart):
*
*   cFile         The content of the new DICOM object
*
* Last Updated     : $Author$
* Update Date Time : $Date$
* RCS File Name    : $RCSfile$
* RCS Revision     : $Revision$
* Locked by        : $Locker$
* Symbolic name    : $Name$
* State            : $State$
*
--%><%@
	page import="imagemed.util.*,imagemed.imsession.*,imagemed.jsputil.*,java.io.*,imagemed.types.flag.IMTypeur"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%
	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	MultipartRequest mp = new MultipartRequest(request, IMEnvBase.getEnv("TMP"));

	String parFile     = mp.getParameter("cFile");
	//tmp file name will be in it
	
	Helper.DEBUG( "uploadAndCreateDicomdir jsp called, parFile:" + parFile );
	
	if (!mp.isMultiPart()) {
		Helper.DEBUG( "Not Multipart request" );
		%>FAILED<%
		return;
	}
	else {
		String tmpDirName = IMEnvBase.getEnv( "TMP" ) + "/createDicomdir." + System.currentTimeMillis();

		Properties names = null;
		try {
			names = Helper.extractFilesFromZip( parFile, tmpDirName, true );
//			Helper.removeDirectoryRecursively( tmpDirName );
		}
		catch( Throwable th ) {
			Helper.ERRORLOG( "Exception in media import extracting (from " + parFile + " to " + tmpDirName + ") :" + Helper.throwable2String( th ) );
		}

		//CD oda
		//ott elkeszit DICOMDIR
		//ezt adnank vissza!?
		List<String> cmd = new ArrayList<String>();
		cmd.add( IMEnvBase.getEnv( "CD_HOME" ) + "/createdicomdir.sh" );
		cmd.add( tmpDirName ); 
		Helper.DEBUG( "uploadAndCreateDicomdir: command is " + Helper.toString( cmd ) );
		RunCommandResult result = Helper.runCommandEx( cmd.toArray( new String[ 0 ] ) );
		String dicomdirFile = tmpDirName + "/"; 
		if ( result.getExitCode() == 0 ) {
			dicomdirFile += "DICOMDIR";
		}
		
		//changing the names to the old ones in the warning/error log
		if( names != null ) {
			Helper.DEBUG( "uploadAndCreateDicomdir: names ok" );
			String outputFileName = tmpDirName + "/createdicomdiroutput";
			File outputFile = new File( outputFileName );
			if( outputFile.exists() ) {
				Helper.DEBUG( "uploadAndCreateDicomdir: exists ok" );
				String content = Helper.readTextFile( outputFileName );
				if( content != null && !"".equals( content.trim() ) ) {
					Helper.DEBUG( "uploadAndCreateDicomdir: content ok" );
					Enumeration<?> elems = names.keys();
					while( elems.hasMoreElements() ) {
						String newName = (String)elems.nextElement();
						String oldName = names.getProperty( newName );
						if( oldName != null ) {
							content = content.replaceAll( newName, oldName );
							Helper.DEBUG( "newname: " + newName + " ,oldname: " + oldName + " content:" + content );
						}
					}
					Helper.writeTextFile( outputFileName, content );
				}
			}
		}
		
		Helper.DEBUG( "return value:'FILE:" + dicomdirFile + "'" );
		
		out.print( "FILE:" + dicomdirFile );
		return;
	}
%>