<%--
 * Component: dotcom
 *
 * Collects device information for dotcom configuration
 * Retrieves deviceid for a peer device (child or parent).
 *
 * This page is used by the peer to figure out self device id in existing dotcom systems.
 *
 * No Parameters:
 *
 * Last Updated     : $Author: rty $
 * Update Date Time : $Date: 2013/10/29 16:22:38 $
 * RCS File Name    : $RCSfile: getdotcomconfig.jsp,v $
 * RCS Revision     : $Revision: 1.10 $
 * Locked by        : $Locker:  $
 * Symbolic name    : $Name:  $
 * State            : $State: Exp $
--%><%@page import="com.erad.pacs.connector.Connector"%>
<%@page import="com.erad.pacs.services.usermanager.client.Session"%>
<%@page import="com.erad.pacs.services.usermanager.client.interfaces.UserManagerFacade"%>
<%@
	page import="imagemed.util.*, imagemed.imsession.*, imagemed.jsputil.*, imagemed.dotcom.*"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><HTML><HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "IMADMIN_GETDOTCOMCONFIG_HTLMPAGE_TITLE" ) %></TITLE><%

	UserManagerFacade userManager = Connector.getInstance().get( UserManagerFacade.Caller );
	Session sess = userManager.getSessitaSession( request, response );

	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(response.getWriter());
%>
</HEAD><BODY>
<BR>
<CENTER>
<%	
	if (sess.getRights().hasAdminRight()) {

		Throwable collectException = null;
		try {
			DotcomConfig.reCollect(response.getWriter(),null);	
		}
		catch (Throwable th) {
			collectException = th;
		}

			
		if ( ! "true".equals( request.getParameter( "serialize" ) ) ) {
				if ( collectException == null ) {
					MessageBox mb = new MessageBox(LocalizedMessage.getSimpleMessage( "IMADMIN_GETDOTCOMCONFIG_DATA_COLLECTED" ),"70%");
					mb.setMessage("<BR><BR>" + LocalizedMessage.getSimpleMessage( "IMADMIN_GETDOTCOMCONFIG_DATA_COLLECTED_MSG" ) + "<BR><BR><BR>");
					mb.addButton(new Button("dicom.jsp","BUTTON_OK","BUTTON_OK"));
					mb.print(response.getWriter());
				}
				else {
					MessageBox mb = new MessageBox(LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ) + "!","70%");
					mb.setMessage("<BR><BR>" + LocalizedMessage.getSimpleMessage( "IMADMIN_GETDOTCOMCONFIG_COULD_NOT_COLLECT_DATA" ) + "<BR><BR><BR>" + Helper.throwable2String( collectException ) );
					mb.addButton(new Button("dicom.jsp","BUTTON_OK","BUTTON_OK"));
					mb.print(response.getWriter());
				}
		}
		else {
			MessageBox mb = new MessageBox(LocalizedMessage.getSimpleMessage( "GENERAL_ERROR_TITLE" ) + "!","70%");
			mb.setMessage("<BR><BR>" + LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) + "<BR><BR><BR>");
			mb.addButton(new Button("dicom.jsp","BUTTON_OK","BUTTON_OK"));
			mb.print(response.getWriter());
		}
	}

%>
</CENTER>
</BODY></HTML>
