<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--
 ** Component: cases
 **
 ** Detaching shortcuts (Converting shortcuts to copy)
 **
 **  @param cStudy        Study Instance UID of shortcut to be detached
 **  @param cBack         URL to go back after edit
 **  @param cOp           Detach operation ('Detach')
 **
 *  Last Updated     : $Author: balage $
 *  Update date/time : $Date: 2014/01/17 14:48:31 $
 *  RCS File Name    : $RCSfile: detach.jsp,v $
 *  RCS Revision     : $Revision: 1.11 $
 *  Locked by        : $Locker:  $
 *  Symbolic name    : $Name:  $
 *  State            : $State: Exp $
-- %><%@
	page import="imagemed.util.*,imagemed.types.flag.IMTypeur,imagemed.exception.*,
			imagemed.imsession.*,imagemed.jsputil.*,java.util.*"
%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%!

	static String m_tabPage = "cases/index.jsp";
	
%><%-- Input Parameters -- %><%IMSession is = new IMSession( request, response, out );
	if (! is.regOK() ) {
		return;
	}

	String parStudy = request.getParameter( "cStudy" );
	String parBack = request.getParameter( "cBack" );
	String parOp = request.getParameter( "cOp" );

	if ( null == parBack ) {
		parBack = request.getHeader( "Referer" );
	}
	if ( null == parBack ) {
		parBack = "javascript:self.history.back();";
	}


	boolean hasCopyRight = is.hasRight( PacsRight.Copy.letterString() );

	if ( parStudy == null ) {
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_NO_STUDIES" ), m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_ERROR_TITLE" ), parBack, 4 );
	}

	String redirHost = RedirectToolbox.getRedirectForStudy( is, parStudy );
	if ( redirHost != null ) {
		String redirURL = redirHost + "/cases/detach.jsp?" + RedirectToolbox.getRedirectParams( is );
		response.sendRedirect( redirURL );
		return;
	}

	if ( !hasCopyRight ) {
		throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_NO_RIGHTS" ), m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_ERROR_TITLE" ), parBack, 4 );
	}

	
	Defs casesDefs = new Defs( is, null );%><HTML>
<HEAD>
<TITLE><%= LocalizedMessage.getSimpleMessage( "OPER_FORWARD" ) %></title>
<%
	imagemed.http.tabs.TabBean.writeStyleOnly( is );
	TabToolbox.writeIMpopup( out );
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( is );
%>
</head>
<BODY>

<CENTER>
<%
	TabToolbox.makeTabs( is, is.tabbean, "cases/index.jsp", "White" );
%>
<FONT face="Arial,Helvetica,Universe">
<%

	String[] studies = new String[] { parStudy };

	Map<String, OperToolbox.RowHighlight> highlights = new HashMap<String, OperToolbox.RowHighlight>();
	if ( parStudy.equals( StudyToolbox.getSourceStudyDB( parStudy ) ) ) {
		highlights.put( parStudy, new OperToolbox.RowHighlight( "BgErrorRow", null, null) );
	}
	
	OperToolbox.InfoTable infoTable = OperToolbox.getPatientNames( studies, is, false, false, highlights );

	String patientTable = infoTable.getStudiesTable();
	
%>
 <TABLE border=1 width="100%" cellpadding=0 cellspacing=0 class=BgShadow>
  <TR><TD>
  <BR>
  <TABLE border=0 width="100%"><TR><TD>
   &nbsp;&nbsp;
   <FONT size=4>
   <%= LocalizedMessage.getSimpleMessage( "CASES_DETACH_SHORTCUT_PAGE" ) %>:
   </FONT>
  </TD></TR></TABLE>
  <BR>
  </TD></TR><TR><TD>
   <%= patientTable %>
  </TD></TR>
 </TABLE>

<%	

	String errFontB = "<FONT color=red><B>";
	String errFontE = "</b></FONT>";


	// Perform actual forward operations
	try {
		
		if ( !highlights.isEmpty() ) {
			throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_NOT_SHORTCUT" ) , m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_ERROR_TITLE" ), null, 3 );
		}

		if ( "Detach".equals( parOp ) ) {
			try {
				FolderToolbox.detachShortcut( is, parStudy );
			}
			catch ( Exception e ) {
				throw new IMGeneralException( is, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_FAILED" ) , m_tabPage, LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_ERROR_TITLE" ), null, 3 );
			}
		
			MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_COMPLETED_TITLE" ), "" );
			mb.setMessage( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_COMPLETED" ) );
			
			throw new IMMessageBoxException( is, mb, m_tabPage, 3, parBack );
		} // END detach shortcut

		
		// Confirmation page
%>
 <FORM action="detach.jsp" name="detachForm" method="POST">
 <%
 		for ( Enumeration<?> e = request.getParameterNames(); e.hasMoreElements(); ) {
			String name = ( String ) e.nextElement();
			String[] values = request.getParameterValues( name );
			for ( int i = 0; values != null && i < values.length; i++ ) {
				String value = values[ i ];
				if (value == null) {
					value = "";
				}
				out.println( "<input type=hidden name=\"" + name + "\" value=\"" + value + "\">" );
			}
		}
 %>
 <INPUT TYPE="hidden" NAME="cOp" VALUE="Detach">
 </FORM>
 <%
		
		MessageBox mb = new MessageBox( LocalizedMessage.getSimpleMessage( "CASES_DETACH_SHORTCUT_PAGE" ), "" );
		mb.setMessage( LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_DETACH_SHORTCUT_CONFIRM_MESSAGE" ) );

		mb.addButton(new Button( "JavaScript:document.detachForm.submit();", "BUTTON_CONTINUE", "ALT_TEXT_CONTINUE" ) );
		throw new IMMessageBoxException( is, mb, m_tabPage, 0, parBack );

	}
	catch ( IMMessageBoxException imbe ) {
		out.println( imbe.getHtmlMessage( is ) );
	}

%>
</body>
</html>
--%>