// Hebrew Language File
// Translation provided by Erel Segal

// Settings
var lang = "he"; // xhtml language
var lang_direction = "rtl"; // language
														// direction:ltr=left-to-right,rtl=right-to-left

// Buttons
var lblSubmit = "שלח"; // Button value for non-designMode() & non fullsceen
													// RTE
var lblModeRichText = "טקסט מעוצב"; // Label of the Show Design view
																							// link
var lblModeHTML = "קוד מקור"; // Label of the Show Code view link
var lblSave = "שמור";
var lblPrint = "הדפס";
var lblSelectAll = "בחר הכל";
var lblSpellCheck = "בדוק איות";
var lblCut = "גזור";
var lblCopy = "העתק";
var lblPaste = "הדבק";
var lblPasteText = "הדבק כטקסט פשוט";
var lblPasteWord = "הדבק מתוך וורד";
var lblUndo = "בטל פעולה אחרונה";
var lblRedo = "בצע שוב";
var lblHR = "קו מפריד";
var lblInsertChar = "סימן מיוחד";
var lblBold = "הדגש";
var lblItalic = "הפוך לכתב נטוי";
var lblUnderline = "מתח קו תחתי";
var lblStrikeThrough = "מתח קו חוצה";
var lblSuperscript = "כתב עילי";
var lblSubscript = "כתב תחתי";
var lblAlgnLeft = "יישר שמאלה";
var lblAlgnCenter = "יישר למרכז";
var lblAlgnRight = "יישר ימינה";
var lblJustifyFull = "יישר לצדדים";
var lblOL = "רשימה ממוספרת";
var lblUL = "רשימה לא ממוספרת";
var lblOutdent = "משוך פיסקה החוצה";
var lblIndent = "דחוף פיסקה פנימה";
var lblTextColor = "צבע טקסט";
var lblBgColor = "צבע רקע";
var lblSearch = "חפש והחלף";
var lblInsertLink = "קישור";
var lblUnLink = "Remove link";
var lblAddImage = "ציור";
var lblInsertTable = "טבלה";
var lblWordCount = "ספור מילים";
var lblUnformat = "בטל עיצוב";
// Dropdowns
// Format Dropdown
var lblFormat = "<option value=\"\" selected=\"selected\">סגנון</option>";
lblFormat += "<option value=\"&lt;h1&gt;\">כותרת 1</option>";
lblFormat += "<option value=\"&lt;h2&gt;\">כותרת 2</option>";
lblFormat += "<option value=\"&lt;h3&gt;\">כותרת 3</option>";
lblFormat += "<option value=\"&lt;h4&gt;\">כותרת 4</option>";
lblFormat += "<option value=\"&lt;h5&gt;\">כותרת 5</option>";
lblFormat += "<option value=\"&lt;h6&gt;\">כותרת 6</option>";
lblFormat += "<option value=\"&lt;p&gt;\">ברירת מחדל של פיסקה</option>";
lblFormat += "<option value=\"&lt;address&gt;\">כתובת</option>";
lblFormat += "<option value=\"&lt;pre&gt;\">מעוצב מראש</option>";
// Font Dropdown
var lblFont = "<option value=\"\" selected=\"selected\">גופן</option>";
lblFont += "<option value=\"Arial, Helvetica, sans-serif\">Arial</option>";
lblFont += "<option value=\"Courier New, Courier, mono\">Courier New</option>";
lblFont += "<option value=\"Palatino Linotype\">Palatino Linotype</option>";
lblFont += "<option value=\"Times New Roman, Times, serif\">Times New Roman</option>";
lblFont += "<option value=\"Verdana, Arial, Helvetica, sans-serif\">Verdana</option>";
var lblApplyFont = "Apply selected font";
// Size Dropdown
var lblSize = "<option value=\"\">גודל</option>";
lblSize += "<option value=\"1\">1</option>";
lblSize += "<option value=\"2\">2</option>";
lblSize += "<option value=\"3\">3</option>";
lblSize += "<option value=\"4\">4</option>";
lblSize += "<option value=\"5\">5</option>";
lblSize += "<option value=\"6\">6</option>";
lblSize += "<option value=\"7\">7</option>";
// Size buttons
var lblIncreasefontsize = "Increase Font Size";
var lblDecreasefontsize = "Decrease Font Size";
// Alerts
var lblSearchConfirm = "הביטוי [SF] נמצא [RUNCOUNT] פעמים.\n\n"; // Leave
																																								// in
																																								// [SF],
																																								// [RUNCOUNT]
																																								// and
																																								// [RW]
lblSearchConfirm += "האם ברצונך להחליף את כל המופעים של הביטוי ב-[RW] ?\n";
var lblSearchAbort = "הפעולה בוטלה.";
var lblSearchNotFound = "לא נמצא.";
var lblCountTotal = "מספר המילים";
var lblCountChar = "תוים שאפשר עוד להוסיף";
var lblCountCharWarn = "זהירות! התוכן ארוך מדי וייתכן שלא יישמר כמו שצריך";
// Dialogs
// Insert Link
var lblLinkBlank = "new window (_blank)";
var lblLinkSelf = "same frame (_self)";
var lblLinkParent = "parent frame (_parent)";
var lblLinkTop = "first frame (_top)";
var lblLinkType = "סוג הקישור";
var lblLinkOldA = "סימניה קיימת";
var lblLinkNewA = "סימניה חדשה";
var lblLinkAnchors = "סימניות";
var lblLinkAddress = "כתובת";
var lblLinkText = "טקסט";
var lblLinkOpenIn = "פתח קישור ב-";
var lblLinkVal0 = "אנא ציין את כתובת הקישור.";
var lblLinkSubmit = "אישור";
var lblLinkCancel = "ביטול";
var lblLinkRelative = "relative";
var lblLinkEmail = "email";
var lblLinkDefault = "Default";
// Insert Image
var lblImageURL = "כתובת ציור";
var lblImageAltText = "טקסט חלופי";
var lblImageVal0 = "אנא ציין את  \"כתובת הציור\".";
var lblImageSubmit = "אישור";
var lblImageCancel = "ביטול";
// Insert Table
var lblTableRows = "שורות";
var lblTableColumns = "עמודות";
var lblTableWidth = "רוחב הטבלה";
var lblTablePx = "פיקסלים";
var lblTablePercent = "אחוזים";
var lblTableBorder = "עובי הגבול";
var lblTablePadding = "רווח בתוך התאים";
var lblTableSpacing = "רווח בין התאים";
var lblTableSubmit = "אישור";
var lblTableCancel = "ביטול";
// Search and Replace
var lblSearchFind = "מה לחפש?";
var lblSearchReplace = "במה להחליף?";
var lblSearchMatch = "הבחן בין אותיות גדולות לקטנות?";
var lblSearchWholeWord = "מצא רק מילים שלמות?";
var lblSearchVal0 = "אנא הכנס ערך לחיפוש";
var lblSearchSubmit = "אישור";
var lblSearchCancel = "ביטול";
// Paste As Plain Text
var lblPasteTextHint = "עצה: כדי להדביק, אפשר להקליק כפתור-ימני ולבחור  \"הדבק\" או להשתמש ב-  Ctrl-V.";
var lblPasteTextVal0 = "אנא הכנס טקסט.";
var lblPasteTextSubmit = "אישור";
var lblPasteTextCancel = "ביטול";
// Paste from Word
var lblPasteWordHint = "עצה: כדי להדביק, אפשר להקליק כפתור-ימני ולבחור  \"הדבק\" או להשתמש ב-  Ctrl-V.";
var lblPasteWordVal0 = "אנא הכנס טקסט.";
var lblPasteWordSubmit = "אישור";
var lblPasteWordCancel = "ביטול";
// non-designMode
var lblAutoBR = "הוסף סופי-שורה באופן אוטומטי";
var lblRawHTML = "השתמש רק בקוד html גולמי";
var lblnon_designMode = 'כדי להשתמש בעורך טקסט מעוצב, דרוש דפדפן <a href="http://www.mozilla.org/" target="_blank">Mozilla 1.3+</a> (לדוגמה, <a href="http://www.getfirefox.com/" target="_blank">Firefox</a>), <a href="http://www.apple.com/safari/download/" target="_blank">Safari 1.3+</a>, <a href="http://www.opera.com/" target="_blank">Opera 9+</a> או <a href="http://www.microsoft.com/windows/products/winfamily/ie/default.mspx" target="_blank">MS IE5.5+</a> (חלונות). הדפדפנים IE5(Mac) עדיין לא נתמכים, וכל הטקסט חייב להיות בקוד  HTML.';
