<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%-- 

**** Quick View Window top frame

-- %><%@page import="com.erad.pacs.common.interfaces.result.SQLResult"%>
<%@
	page import="java.util.*, java.io.*, java.sql.*,
		imagemed.imsession.*, imagemed.exception.IMException, imagemed.util.*,
		com.erad.pacs.app.broker.table.internals.*,com.erad.pacs.app.broker.table.internals.imtables.*, com.erad.pacs.app.broker.table.internals.action.*,
			com.erad.pacs.app.broker.table.internals.lists.*, com.erad.pacs.app.broker.table.internals.imtables.DBLDSWrapperSqlResultImpl.IncrementalContextImpl,
		imagemed.checkintegrity.*, java.text.Format"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"
    
%><%!


	static String[] DB_FIELDS = new String[] { "ACCN", "PANM", "PAID", "MODY", "SYDT", "DSCR", "STAT", "RPST", "FLDR", "STDE" };

	static void printTableHead( PrintWriter out, String title, String width, String divname ) throws IOException {
		out.println( "<DIV ID=\"" + divname + "\" class=\"movable\" style=\"width: " + width + ";\">" );
		out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"2\" cellspacing=\"0\">" );
		out.println( "<TR class=\"draggable\" onMouseDown=\"IMDRAG.down( event, '" + divname + "' )\" onMouseUp=\"IMDRAG.up()\">" );
		out.println( "<TD class=\"BgShadow\"  colspan=2 align=center><B>" + Helper.htmlEncode( title ) + "</B></TD></TR>" );
	}

	static void printTableTail( PrintWriter out ) throws IOException {
		out.println( "</TABLE>" );
		out.println( "</DIV>" );
	}

	static void printTableRow( IMSession is, String title, String content, String contentId, String url ) throws IOException {
		PrintWriter out = is.out;
		out.print( "<TR><TD class=\"BgMedDark\">" );
		out.print( Helper.htmlEncode( title ) );
		StringBuffer styles = new StringBuffer();
		styles.append( "white-space: nowrap;" );
		if ( content != null ) {
			styles.append( "cursor: pointer;" );
		}
		
		out.print( "</TD><TD class=\"BgShadow\" style=\"" + styles + "\"" );
		if ( content == null ) {
			out.print( ">&nbsp;" );
		}
		else {
			out.print( " onMouseDown=\"toggle( '" + contentId + "', '" + url + "');\">" );
			out.print( Helper.htmlEncode( content ) );
		}
		out.println( "</TD></TR>" );

		if ( content != null ) {
			String style = "visibility: collapse;";
			if ( is.bIsMSIE ) {
				style = "display: none";
			}

			out.print( "<TR ID=\"tr_" + contentId + "\" style=\"" + style + "\">" );
			out.print( "<TD colspan=2><font size=-1>" );
			out.print( "<DIV ID=\"div_" + contentId + "\" style=\"overflow: auto; max-height: 150px; width: 750px;\">" );
			out.println( "</DIV></font></TD></TR>" );
		}
	}

	static void printStudyDirs( IMSession is, String study ) throws SQLException, IOException {
		PrintWriter out = is.out;
	
		String studyDir = RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_DICOM_DATA") , study );
		String processedDir = RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_PROCESSED") , study );
		String cacheDir = RepositoryHandler.getLocation( IMEnvBase.getEnv( "REPOSITORY_CACHE") , study );
		
		String archiveConf = IMEnv.getConfigProperty( IMEnvBase.getEnv( "ARCHIVE_VAR" ) + "/archive.cfg", "Archive" );
		boolean hasArchive = "yes".equals( archiveConf ) || "readonly".equals( archiveConf );
		String archiveDir = null;
		if ( hasArchive ) {
			try ( ResultSet rs = IMEnv.getDB().prepareStatement( "select ARCHDIR from Archive where STYIUID='" + study + "'" ).executeQuery() ) {
				if ( rs.next() ) {
					archiveDir = IMEnvBase.getEnv( "ARCHIVE_DIR" ) + "/" + rs.getString( "ARCHDIR" ) + "/" + study;
				}
			}
		}

		printTableHead( out, LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_STUDY_DIRECTORIES" ), "750px", "studydirs_obj" );

		printTableRow( is, LocalizedMessage.getSimpleMessage( "IMADMIN_SRVINFO_DATA" ), studyDir, "studydata", "/cases/getStudyInfo.jsp?cStudy=" + study + "&cOp=ls&cMode=studydata" );
		printTableRow( is, LocalizedMessage.getSimpleMessage( "IMADMIN_SRVINFO_PROCESSED" ) , processedDir, "processeddir", "/cases/getStudyInfo.jsp?cStudy=" + study + "&cOp=ls&cMode=processed" );
		printTableRow( is, LocalizedMessage.getSimpleMessage( "IMADMIN_SRVINFO_CACHE" ), cacheDir, "cachedir", "/cases/getStudyInfo.jsp?cStudy=" + study + "&cOp=ls&cMode=cache" );

		if ( hasArchive ) {
			printTableRow( is, LocalizedMessage.getSimpleMessage( "tabArchive" ), archiveDir, "archivedir", "/cases/getStudyInfo.jsp?cStudy=" + study + "&cOp=ls&cMode=archive" );
		}

		printTableRow( is, LocalizedMessage.getSimpleMessage( "GENERIC_INFO" ), studyDir == null ? null : studyDir + "/.info", "studyinfo", "/cases/getStudyInfo.jsp?cStudy=" + study + "&cOp=ls&cMode=studyinfo" );

		printTableTail( out );
	}


	static void printStudyDB( PrintWriter out, String study ) throws IOException {
		TableDescriptorImpl tdesc = new TableDescriptorImpl( null, false, false, false, false );
		TablePropertiesImpl tprop = new TablePropertiesImpl();
		FieldManagerImpl fm = new IMSQLFieldManagerImpl( "Dcfields", "Dctypes", "Dcstudy" );
		TableParamsImpl tparams= new TableParamsImpl();
		
		Properties filterProps = new Properties();
		filterProps.setProperty( "SYUI", study );
		
		tparams.setFilters( filterProps );
		tparams.setFields( DB_FIELDS );
		
		tdesc.setTableParams(tparams);
		tdesc.setTablePackage("imagemed.imtables");
		tdesc.setTableProperties(tprop);
		tdesc.setFieldManager(fm);
		tdesc.setSortDepth(3);

		printTableHead( out, LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_STUDY_TABLE" ), "350px", "studytable_obj" );

		SQLResult sqlRes = new SQLResultImpl( tdesc );
		
		if ( sqlRes.next() ) {
			for ( int i = 0; i < DB_FIELDS.length; i++ ) {
				out.print( "<TR><TD class=\"BgMedDark\" style=\"border-color: black\">" );
				out.print( fm.getHeaderName( DB_FIELDS[ i ] ) );
				out.print( "</TD><TD class=\"BgShadow\" style=\"border-color: black\">" );
				out.print( Helper.htmlEncode( sqlRes.getValue( DB_FIELDS[ i ] , "" ) + " ", true ) );
				out.println( "</TD></TR>" );
			}
		}
		else {
			out.println( "<TR><TD colspan=2> " + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NO_STUDY_TABLE_ENTRY" ) + " </TD></TR>" );
		}
		
		sqlRes.close();
		printTableTail( out );
	}

	static void printStoreState( PrintWriter out, String study ) throws IOException, IMException {
		
		StoreState st = new StoreState( study );
		
		printTableHead( out, LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_STORE_STATE" ), "350px", "storestate_obj" );

		if ( st.load() ) {
			Properties prp = st.getContent();
			String keys[] = prp.keySet().toArray( new String[ 0 ] );
			Arrays.sort( keys );
			
			for ( int i = 0; i < keys.length; i++ ) {
				out.print( "<TR><TD class=\"BgMedDark\">" );
				out.print( keys[ i ] );
				out.print( "</TD><TD class=\"BgShadow\">" );
				out.print( Helper.htmlEncode( prp.getProperty( keys[ i ] ) ) );
				out.println( "</TD></TR>" );
			}
		}
		else {
			out.println( "<TR><TD colspan=2> " + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_FILE_NOT_LOADED_FOR_STUDY" ) + " </TD></TR>" );
		}
		
		printTableTail( out );
	}

	static void printReferences( IMSession is, String study ) throws IOException {
		PrintWriter out = is.out;
		
		ReferenceCounter rcDB = new ReferenceCounter( "STUDYDB", study );

		out.println( "<BR>" );
		// Outer table
		out.println( "<TABLE style=\"width: 700px;\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\">" );
		out.println( "<TR><TD>" );
		
		
		out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\">" );
		out.println( "<TR><TD class=\"BgShadow\" align=center><B>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_STUDYDB_REF" ) + "</B></TD></TR>" );

		if ( rcDB.load() ) {
			Hashtable<String, Integer> referrers = rcDB.copyReferrers();
			if ( referrers.isEmpty() ) {
				out.println( "<TR><TD><I>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NO_STUDYDB" ) + "</I></TD></TR>" );
			}
			
			for ( Enumeration<String> e = referrers.keys(); e.hasMoreElements(); ) {
				String ref = e.nextElement();
				int mp = referrers.get( ref ).intValue();
				out.print( "<TR><TD class=\"reference\">" );
				out.print( ref );
				out.print( " [" );
				out.print( mp );
				out.println( "]</TD></TR>" );
			}
		}
		else {
			out.println( "<TR><TD><I>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NO_STUDYDB_COUNTER" ) + "</I></TD></TR>" );
		}
		out.println( "</TABLE>" );

		out.println( "<BR>" );
		
		
		
		TreeMap<String, Hashtable<String, Integer>> objFileRefs = new TreeMap<String, Hashtable<String, Integer>>();
		TreeSet<String> allReferences = new TreeSet<String>();
		String objFilesDir = DirHash.getHashed( study );
		if ( objFilesDir != null ) {
			String objFilesDirFullPath = IMEnvBase.getEnv( "REFCOUNT_VAR" ) + "/OBJECTFILE/" + objFilesDir;
			out.println( "<!-- " + objFilesDirFullPath + " -->" );
			String[] files = Helper.getDirectoryContentAsStringArray( objFilesDirFullPath );
			if ( files != null ) {
				for ( int i = 0; i < files.length; i ++ ) {
					if ( ".".equals( files[ i ] ) || "..".equals( files[ i ] ) ) {
						continue;
					}
					
					ReferenceCounter rcOBJ = new ReferenceCounter( "OBJECTFILE", study + "/" + files[ i ] );
					rcOBJ.load();
					Hashtable<String, Integer> referrers = rcOBJ.copyReferrers();
					objFileRefs.put( files[ i ], referrers );
					allReferences.addAll( referrers.keySet() );
				}
			}
		}

		Hashtable<String, Integer> fileRefs = new Hashtable<String, Integer>();
		Hashtable<String, Integer> nonFileRefs = new Hashtable<String, Integer>();
		ReferenceCounter rcDIR = new ReferenceCounter( "STUDYDIR", study );
		boolean hasDirRefFile = rcDIR.load();
		if ( hasDirRefFile ) {
			Hashtable<String, Integer> referrers = rcDIR.copyReferrers();
			for ( Enumeration<String> e = referrers.keys(); e.hasMoreElements(); ) {
				String ref = e.nextElement();
				Integer mp = referrers.get( ref );
				
				if ( objFileRefs.containsKey( ref ) ) {
					fileRefs.put( ref, mp );
				}
				else {
					nonFileRefs.put( ref, mp );
				}
			}
		}

		out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\">" );
		out.println( "<TR><TD class=\"BgShadow\" align=center><B>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_STUDYDIR_REF" ) + "</B></TD></TR>" );

		if ( !hasDirRefFile ) {
			out.println( "<TR><TD><I>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_STUDYDIR_REF_COUNTER" ) + "</I></TD></TR>" );
		}
		else {
			out.println( "<TBODY><TR><TD class=\"BgMedDark\">" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NON_OBJ_FILE_REF" ) + "</TD></TR>" );
			if ( nonFileRefs.isEmpty() ) {
				out.println( "<TR><TD><I>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NO_NON_OBJ_FILE_REF" ) + "</I></TD></TR>" );
			}
			else {
				for ( Enumeration<String> e = nonFileRefs.keys(); e.hasMoreElements(); ) {
					String ref = e.nextElement();
					int mp = nonFileRefs.get( ref ).intValue();
					out.print( "<TR><TD class=\"reference\">" );
					out.print( ref );
					out.print( " [" );
					out.print( mp );
					out.println( "]</TD></TR>" );
				}
			}
			out.println( "</TBODY>" );

			out.println( "<TBODY><TR><TD class=\"BgMedDark\">" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_OBJ_FILE_REF" ) + "</TD></TR>" );
			if ( fileRefs.isEmpty() ) {
				out.println( "<TR><TD><I>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NO_OBJ_FILE_REF" ) + "</I></TD></TR>" );
			}
			else {
				out.print( "<TR><TD class=\"BgShadow\" style=\"white-space: nowrap; cursor: pointer;\"" );
				out.print( " onMouseDown=\"toggleObj( 'filerefs' );\">" );
				
				Format[] msgFormat = new Format[] { null };
				Object[] msgObject = new Object[] { fileRefs.size() }; 
				String messageID = "CASES_STUDYINFOBODY_THERE_IS_OBJ_FILE_REF";
				if ( fileRefs.size() > 1 ) { 
					messageID += "_PLURAL";
				}
				
				out.print( LocalizedMessage.getCompoundMessage( messageID, msgFormat, msgObject, true ) );
				
				//if ( fileRefs.size() == 1 ) {
				//	out.print( "There is " + fileRefs.size() + " object file reference" );
				//}
				//else {
				//	out.print( "There are " + fileRefs.size() + " object file references" );
				//}
				
				out.println( ".&nbsp;&nbsp; " + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_SHOW_HIDE_DETAILS" ) + "</TD></TR>" );

				String style = "visibility: collapse;";
				if ( is.bIsMSIE ) {
					style = "display: none";
				}

				out.print( "<TR ID=\"tr_filerefs\" style=\"" + style + "\">" );
				out.println( "<TD><TABLE border=none cellpadding=0 cellspacing=0 width=\"100%\">" );
				
				for ( Enumeration<String> e = fileRefs.keys(); e.hasMoreElements(); ) {
					String ref = e.nextElement();
					int mp = fileRefs.get( ref ).intValue();
					out.print( "<TR><TD class=\"reference\">" );
					out.print( ref );
					out.print( " [" );
					out.print( mp );
					out.println( "]</TD></TR>" );
				}
				out.println( "</TABLE></TD></TR>" );
			}
			out.println( "</TBODY>" );
		}
		out.println( "</TABLE>" );
		out.println( "<BR>" );
	

		out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\">" );
		out.println( "<TR><TD class=\"BgShadow\" align=center><B>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_OBJECTFILE_REF" ) + "</B></TD></TR>" );
		if ( objFileRefs.isEmpty() ) {
			out.println( "<TR><TD><I>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NO_OBJ_FILE_REF" ) + "</I></TD></TR>" );
		}
		else {
			out.print( "<TR><TD class=\"BgMedDark\">" );
			
			Format[] msgFormat = new Format[] { null, null };
			Object[] msgObject = new Object[] { objFileRefs.size(), allReferences.size() };
			String messageID = "CASES_STUDYINFOBODY_REF_COUNTER_WITH_DIFF_REF";
			if ( objFileRefs.size() > 1 ) {
				messageID += "_PLURAL";
			}
			
			//if ( objFileRefs.size() == 1 ) {
			//	out.print( "There is " + objFileRefs.size() + " reference counter with " + allReferences.size() + " different reference(s)" );
			//}
			//else {
			//	out.print( "There are " + objFileRefs.size() + " reference counters with " + allReferences.size() + " different reference(s)" );
			//}
			
			out.print( LocalizedMessage.getCompoundMessage( messageID, msgFormat, msgObject, true) );
			
			out.println( "</TD></TR>" );
			for ( Iterator<String> i2 = allReferences.iterator(); i2.hasNext(); ) {
				String ref = i2.next();
				out.print( "<TR><TD class=\"reference\">" );
				out.print( ref );
				out.println( "</TD></TR>" );
			}

			out.print( "<TR><TD class=\"BgMedDark\" style=\"white-space: nowrap; cursor: pointer;\"" );
			out.print( " onMouseDown=\"toggleObj( 'allrefs' );\">" );
			out.println( LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_SHOW_HIDE_DETAILS" ) + "</TD></TR>" );

			String style = "visibility: collapse;";
			if ( is.bIsMSIE ) {
				style = "display: none";
			}

			out.print( "<TR ID=\"tr_allrefs\" style=\"" + style + ";\">" );
			out.println( "<TD><TABLE border=none cellpadding=0 cellspacing=0 width=\"100%\">" );
			
			for ( Iterator<String> iter = objFileRefs.keySet().iterator(); iter.hasNext(); ) {
				String objFile = iter.next();
				Hashtable<String, Integer> refs = objFileRefs.get( objFile );
				out.println( "<TR><TD class=\"BgShadow\">" + Helper.htmlEncode( objFile ) + "</TD></TR>" );
				if ( refs.isEmpty() ) {
					out.println( "<TR><TD><I>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_OBJ_FILE_REF_COUNTER_EMPTY" ) + "</I></TD></TR>" );
				}
				else {
					for ( Enumeration<String> e = refs.keys(); e.hasMoreElements(); ) {
						String ref = e.nextElement();
						int mp = refs.get( ref ).intValue();
						out.print( "<TR><TD class=\"reference\">" );
						out.print( ref );
						out.print( " [" );
						out.print( mp );
						out.println( "]</TD></TR>" );
					}
				}
			}
			out.println( "</TABLE></TD></TR>" );
		}
		out.println( "</TABLE>" );
	}
	
	
	static void printIntegrityException( IMSession is, Exception ex ) throws IOException {
		PrintWriter out = is.out;
		String style = "visibility: collapse;";
		if ( is.bIsMSIE ) {
			style = "display: none";
		}
		
		out.println( "<TABLE width=\"90%\" border=\"1\" cellpadding=\"2\" cellspacing=\"0\">" );
		out.print( "<TR><TD class=\"BgShadow\" style=\"cursor: pointer;\" onMouseDown=\"toggleObj('cierrmsg')\" align=center>" );
		out.print( "<BR><B>" + LocalizedMessage.getSimpleMessage( "EXCEPTION_CASES_STUDYINFOBODY_INTEGRITY_ERROR" ) + ": <FONT color=red>" );
		out.print( ex.getMessage() );
		out.println( "</font></B><BR><BR></TD></TR>" );
		
		out.print( "<TR ID=\"tr_cierrmsg\" style=\"" + style + "\">" );
		out.print( "<TD><font size=-1>" );
		out.print( "<DIV ID=\"div_cidebug\" style=\"overflow: auto; height: 250px; width: 750px;\"><pre>" );
		out.print( Helper.throwable2String( ex ) );
		out.println( "</pre></DIV></font></TD></TR>" );
		out.println( "</TABLE>" );

	}
	                                                                  

	static void printIntegrityStatus( IMSession is, String message, boolean isOK ) throws IOException {
		PrintWriter out = is.out;
		
		out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\">" );
		out.println( "<TR><TD class=\"BgShadow\" align=center><BR><B>" );
		out.print( "<FONT color=\"" + ( isOK ? "green" : "red" ) + "\">" );
		out.print( message );
		out.print( "</FONT></B><BR><BR></TD></TR>" );
		out.println( "</TABLE>" );
	}

	static void printIntegrityTable( IMSession is, String study ) throws IOException, SQLException, IMException {
		PrintWriter out = is.out;

		out.println( "<BR>" );
		// Outer table
		out.println( "<TABLE style=\"width: 700px;\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\" align=\"center\">" );
		out.println( "<TR><TD>" );
		
		// Inner table for header
		out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"15\" cellspacing=\"0\">" );
		out.println( "<TR><TD class=\"BgShadow\" align=left><B><FONT size=\"4\">" );
		out.print( LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_INTEGRITY_CHECK" ) );
		out.print( "</B></FONT></TD></TR></TABLE>" );

		out.flush();
		
		printIntegrityInfo( is, study );

		// Close outer table		
		out.print( "</TD></TR></TABLE>" );
	}

	static void printOutputTable( IMSession is, Writer debugOut ) throws IOException {
		PrintWriter out = is.out;

		String style = "visibility: collapse;";
		if ( is.bIsMSIE ) {
			style = "display: none";
		}
		
		out.println( "<BR><BR>" );

		out.println( "<TABLE border=\"1\" cellpadding=\"2\" cellspacing=\"0\" width=\"100%\">" );
		out.print( "<TR><TD class=\"BgShadow\" style=\"cursor: pointer;\" onMouseDown=\"toggleObj('cidebug')\" align=center>" );
		out.println( LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_VIEW_OUTPUT" ) + "</TD></TR>" );
		
		out.print( "<TR ID=\"tr_cidebug\" style=\"" + style + "\">" );
		out.print( "<TD><font size=-1>" );
		out.print( "<DIV ID=\"div_cidebug\" class=\"expanded\" style=\"width:750px; max-width: 750px;\">" );
		out.print( Helper.htmlEncode( debugOut.toString(), true, true ) );
		out.println( "</DIV></font></TD></TR>" );
		out.println( "</TABLE>" );
	}
	
	static void printIntegrityInfo( IMSession is, String study ) throws IOException, SQLException, IMException {
		PrintWriter out = is.out;

		class IntegrityResults {
			String m_configName;
			String m_configSetting;
			String m_recoveryMethod;
			HashSet< String > m_validSettings;
			Vector< String > m_errorInstances;
			
			IntegrityResults( String configName, String configSetting, String recoveryMethod, HashSet<String> validSettings ) {
				m_configName = configName;
				m_configSetting = configSetting;
				m_recoveryMethod = recoveryMethod;
				m_validSettings = validSettings;
				m_errorInstances = new Vector< String>();
			}
			
			void addErrorInstance( String errorInstance ) {
				m_errorInstances.add( errorInstance );	
			}
		}

		boolean doRecover = "recover".equals( is.request.getParameter( "cOp" ) );
		boolean doCheck = "check".equals( is.request.getParameter( "cOp" ) );

		boolean hasSupportRight = is.hasRight( imagemed.types.flag.PacsRight.Support.letterString() );

		// Only allow recover if the user has support right
		doRecover = doRecover && hasSupportRight;
		
		String style = "visibility: collapse;";
		if ( is.bIsMSIE ) {
			style = "display: none";
		}

		if ( doRecover || doCheck ) {
			int numCS = 0;
			try {
				numCS = Integer.parseInt( is.request.getParameter( "cNumCS" ) );
			}
			catch ( Throwable th ) {
			}

			Properties prpConfig = new Properties(); 
			for ( int i = 0; i < numCS; i++ ) {
				String settingName = is.request.getParameter( "cn_" + i );
				String settingValue = is.request.getParameter( "cs_" + i );
				
				if ( settingName != null && settingValue != null ) {
					prpConfig.setProperty( settingName, settingValue );
				}
			}
			
			Writer debugOut = new StringWriter();
			
			ErrorList errors = new ErrorList( debugOut, null, prpConfig, !doRecover );
			StudyIntegrity integrityChecker = new StudyIntegrity( study, errors, debugOut, null, StudyIntegrity.OWNER_STATUS_UNKNOWN, "partial" );

			try {
				integrityChecker.check();
			}
			catch ( Exception ex ) {
				printIntegrityException( is, ex );
				printOutputTable( is, debugOut );
				return;
			}
			
			int numError = errors.size();
			if ( numError == 0 ) {
				printIntegrityStatus( is, LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NO_INCONSISTENCY" ), true );
				printOutputTable( is, debugOut );
				return;
			}

			debugOut.write( LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_DETECTED_ERRORS" ) + ":\n" );
			errors.print( debugOut );

			if ( doRecover ) {
				debugOut.write( "\n" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_TRY_TO_RECOVER_ERRORS" ) + "\n" );
			}
			else {
				debugOut.write( "\n" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_CHECK_ERRORS_NO_RECOVER" ) + ":\n" );
			}
			
			//Check study, display DEBUG, try to correct detected errors if -r arg vas given
			boolean hasAnyErrorBeenRecovered = false;
			try {
				hasAnyErrorBeenRecovered = errors.handleErrors( debugOut );
			}
			catch ( Exception ex ) {
				printIntegrityException( is, ex );
				printOutputTable( is, debugOut );
				return;
			}

			// TODO: track ignored errors and report them as 'warning'
			errors.handleErrors( debugOut );
			errors.printAll( debugOut );

			if ( errors.size() == 0 ) {
				printIntegrityStatus( is, LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_INCONSISTENCIES_RECOVERED" ), true );
				printOutputTable( is, debugOut );
				return;
			}

			if ( doRecover ) {
				printIntegrityStatus( is, LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_SOME_INCONSISTENCIES_NOT_RECOVERED" ), false );
			}
			else {
				printIntegrityStatus( is, LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_DETECTED_INCONSISTENCIES" ), false );
			}

			Vector < IntegrityResults > inconsistencies = new Vector< IntegrityResults >();
			
			for ( Iterator<IntegrityError> iter = errors.iterator(); iter.hasNext(); ) {
				IntegrityError ie = iter.next();
				String instance = ie.toString();
				String settingName = ie.getSettingName();
				String settingValue = ie.getSettingValue();
				String recoveryMethod = ie.getRecoveryMethod();
				HashSet<String> validSettings = ie.getValidSettings();

				IntegrityResults results = null;
				for ( Iterator<IntegrityResults> i2 = inconsistencies.iterator(); i2.hasNext(); ) {
					IntegrityResults ir = i2.next();
					if ( settingName == null ) {
						if ( ir.m_configName == null ) {
							results = ir;
						}
						break;
					}
					
					if ( settingName.equals( ir.m_configName ) ) {
						results = ir;
						break;
					}
				}
				
				if ( results == null ) {
					results = new IntegrityResults( settingName, settingValue, recoveryMethod, validSettings);
					inconsistencies.add( results );
				}
				
				results.addErrorInstance( instance );
			}

			if ( hasSupportRight ) {
				out.println( "<FORM NAME=\"integrityForm\" ACTION=\"studyInfoBody.jsp\" METHOD=\"POST\">" );
			}
			out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\">" );
			
			String headers = "";
			headers += LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_INCONSISTENCY_NAME" );
			headers += ",";
			headers += LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_RECOVERY_METHOD" );
			headers += ",";
			headers += LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_NUMBER_ERRORS" );
			headers += ",";
			headers += LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_CONFIG_SETTINGS" );
			
			// out.println( Helper.header3D( "Inconsistency Name,Recovery Method,# Errors,Config Setting" ) );
			out.println ( Helper.header3D( headers ) );
			
			int cntSettings = 0;
			int cntErrors = 0;
			for ( Iterator<IntegrityResults> iter = inconsistencies.iterator(); iter.hasNext(); ) {
				IntegrityResults ie = iter.next();
				String settingName = ie.m_configName == null ? LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_UNHANDLED_INCONSISTENCY" ) : ie.m_configName;
				out.println( "<TR>" );
				out.println( "<TD class=\"BgMedDark\"><SPAN style=\"margin: 15px 0px;\">" + settingName + "</SPAN></TD>" );
				out.println( "<TD class=\"BgShadow\"><SPAN style=\"margin: 15px 0px;\">" + ( ie.m_recoveryMethod == null ? "-" : ie.m_recoveryMethod ) + "</SPAN></TD>" );
				out.println( "<TD class=\"BgShadow\" style=\"cursor: pointer;\" onMouseDown=\"toggleObj('details" + cntErrors + "')\" align=center><SPAN style=\"margin: 15px 0px;\">" + ie.m_errorInstances.size() + "</SPAN></TD>" );
				out.println( "<TD class=\"BgShadow\"><SPAN style=\"margin: 15px 0px;\">" );
				if ( ie.m_configName == null || !hasSupportRight ) {
					out.print( "-" );
				}
				else {
					out.println( "<INPUT TYPE=\"hidden\" NAME=\"cn_" + cntSettings + "\" VALUE=\"" + Helper.htmlEncode( ie.m_configName ) + "\">" );
					out.println( "<SELECT NAME=\"cs_" + cntSettings + "\">" );
					out.println( "<OPTION VALUE=\"NONE\"> --- " + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_SELECT_VALUE_SETTING" ) + " ---" );
					for ( Iterator<String> i2 = ie.m_validSettings.iterator(); i2.hasNext(); ) {
						String s = i2.next();
						String selected = s.equals( ie.m_configSetting ) ? " selected" : "";
						out.println( "<OPTION VALUE=\"" + Helper.htmlEncode( s ) + "\"" + selected + ">" + Helper.htmlEncode( s ) );						
					}
					out.println( "<OPTION VALUE=\"ignore\"> " + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_OPTION_IGNORE" ) );
					out.println( "</SELECT>" );
					cntSettings++;
				}
				out.println( "</SPAN></TD>" );

				out.print( "<TR ID=\"tr_details" + cntErrors + "\" style=\"" + style + "\">" );
				out.print( "<TD colspan=5>" );
				out.print( "<DIV ID=\"div_details" + cntErrors + "\">" );
				out.println( "<TABLE>" );
				for ( Iterator<String> i3 = ie.m_errorInstances.iterator(); i3.hasNext(); ) {
					String s = i3.next();
					out.println( "<TR><TD>" + Helper.htmlEncode( s ) + "</TD></TR>" );
				}
				out.println( "</TABLE>" );
				out.println( "</DIV></TD></TR>" );
				cntErrors++;
			}
			
			out.println( "<TR><TD colspan=\"4\" class=\"BgShadow\">" );
			out.println( "<TABLE width=\"100%\" border=0><TR><TD><BR>" );
			if ( doRecover && hasAnyErrorBeenRecovered ) {
				out.println("<B>" + LocalizedMessage.getSimpleMessage( "CASES_STUDYINFOBODY_DORECOVER_AND_ANYERRORECOREVERED" ) + "</B><BR>");
			}
			else {
				out.println( "&nbsp;<BR>" );
			}
			out.println( "<BR></TD>" );

			if ( hasSupportRight ) {   
				out.print( "<TD width=\"15%\" align=right>" );
				out.print( "<A href=\"JavaScript:doSubmit(self.document.integrityForm,'check');\">" );
				out.print( JSHelper.getJsLocalizedButton( "BUTTON_CHECK", "BUTTON_CHECK_STUDY_TITLE", false ) ); 
				out.println( "</a>&nbsp;</TD>" );
			}
			
			if ( hasSupportRight && ( !doRecover || !hasAnyErrorBeenRecovered ) ) {
				out.print( "<TD width=\"15%\" align=right>" );
				out.print( "<A href=\"JavaScript:doSubmit(self.document.integrityForm,'recover');\">" );
				//out.print( JSHelper.getJsButton( is, "Recover", "Recover inconsistencies" ) );
				out.print( JSHelper.getJsLocalizedButton( "BUTTON_RECOVER", "BUTTON_RECOVER_TITLE", false ) );
				out.println( "</a>&nbsp;</TD>" );
			}

			out.println( "</TR></TABLE>" );
			
			out.println( "</TD></TR></TABLE>" );
			if ( hasSupportRight ) {
				out.println( "<INPUT TYPE=HIDDEN NAME=\"cNumCS\" VALUE=\"" + cntSettings + "\">" );
				out.println( "<INPUT TYPE=HIDDEN NAME=\"cStudy\" VALUE=\"" + Helper.htmlEncode( study ) + "\">" );
				out.println( "<INPUT TYPE=HIDDEN NAME=\"cMode\" VALUE=\"integrity\">" );
				out.println( "<INPUT TYPE=HIDDEN NAME=\"cOp\" VALUE=\"\">" );
				out.println( "</FORM>" );
			}

			if ( hasSupportRight ) {
				printOutputTable( is, debugOut );
			}
			return;
		}

		out.println( "<TABLE width=\"100%\" border=\"1\" cellpadding=\"0\" cellspacing=\"0\">" );
		out.println( "<TR>" );
		out.println( "<TD class=\"BgShadow\" align=right><BR><B>" );
		out.print( "<A href=\"studyInfoBody.jsp?cStudy=" + Helper.URLEncodeUTF8( study ) + "&cMode=integrity&cOp=check\">" );
		out.print( JSHelper.getJsLocalizedButton( "BUTTON_CHECK", "BUTTON_CHECK_STUDY_TITLE", false ) );
		out.println( "</A>&nbsp;</B><BR><BR></TD></TR></TABLE>" );
	}
	
%><%

	IMSession is = new IMSession(request, response, out);

	is.bRegNotNeeded = true;
	try {
		is.regOK();
	}
	catch (Throwable th) {
	}

	boolean hasSupportRight = is.hasRight( imagemed.types.flag.PacsRight.Support.letterString() );
	boolean hasAdminRight = is.hasRight( imagemed.types.flag.PacsRight.Admin.letterString() );

	if ( !hasSupportRight && !hasAdminRight ) {
		out.println( "<HTML><HEAD><TITLE>" + LocalizedMessage.getSimpleMessage( "HAS_NO_RIGHTS" ) + "</TITLE><HEAD><BODY><CENTER><H3>" + LocalizedMessage.getSimpleMessage( "NO_PERMISSION_TO_THIS_PAGE" ) + "</H3></CENTER>" );
		out.println( "<script language=\"JavaScript\">" );
		out.print( "   setTimeout( '" );
		out.print( "window.close()" );
		out.print( "', " + ( 5000 ) + ");" );
		out.println( "</script>" );
		out.println( "</BODY></HTML>" );
		return;
	}

	
	String study = request.getParameter( "cStudy" );
	String mode = request.getParameter( "cMode" );

	
%><!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">
<HTML><HEAD><%

	imagemed.http.tabs.TabBean.writeStyleOnly( new imagemed.imsession.IMSession( request, response, out ) );
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript( is );

	JSHelper.printJsInclude( out, JSHelper.IMPOPUP_JS );

%>
<style type="text/css">
	.movable {
		position : relative;
	}

	.draggable {
		cursor : move;
	}

	TABLE {
		border-color: black;
	}

	TD {
		border-color: black;
	}
	
	.expanded {
		overflow: auto;
		height: 250px;
		font-family: "courier,monospace";
	}

	.reference {
		padding-left:50px;
	}	
</style>

<script type="text/javascript">

//Stop Opera selecting anything whilst dragging.
if ( window.opera ) {
	document.write( "<input type='hidden' id='Q' value=' '>" );
}

var IMDRAG = {

	n : 500,
	dragok : false,
	y : 0,
	x : 0,
	d : null,
	dy : 0,
	dx : 0,
	origpos : null,
	origzx : 0,

	grid : 25,

	getAbsolutePos: function( theElem ) {
		var posX = 0;
		var posY = 0;
		var e = theElem;
				             
		while( e != null ) {
			if ( e.clientLeft ) {
				posX += e.offsetLeft - e.scrollLeft + e.clientLeft;
				posY += e.offsetTop - e.scrollTop + e.clientTop;
			}
			else {
				posX += e.offsetLeft;
				posY += e.offsetTop;
			}
			e = e.offsetParent;
		}
                       		      
		return { x:posX, y: posY };
	},
			
	move: function( e ) {
		if ( !e ) {
			e = window.event;
		}
		if ( IMDRAG.dragok ) {
			IMDRAG.d.style.left = IMDRAG.dx + e.clientX - IMDRAG.x + "px";
			IMDRAG.d.style.top  = IMDRAG.dy + e.clientY - IMDRAG.y + "px";
			return false;
		}
	},

			
	down: function( e, objid ) {
		if ( !e ) {
			e = window.event;
		}

		IMDRAG.d = getelementbyid( objid );

		IMDRAG.origpos = IMDRAG.getAbsolutePos( IMDRAG.d );

		IMDRAG.dragok = true;

		IMDRAG.origzx = IMDRAG.d.style.zIndex = IMDRAG.n++;

		IMDRAG.dx = parseInt( IMDRAG.d.style.left + 0 );
		IMDRAG.dy = parseInt( IMDRAG.d.style.top + 0 );
		IMDRAG.x = e.clientX;
		IMDRAG.y = e.clientY;

		document.onmousemove = IMDRAG.move;
		return false;
	},

	up: function() {
		if ( ! IMDRAG.dragok ) {
			return;
		}
				
		IMDRAG.dragok = false;
		document.onmousemove = null;

		var newpos = IMDRAG.getAbsolutePos( IMDRAG.d );
		
		var divx = parseInt( newpos.x / IMDRAG.grid );
		var divy = parseInt( newpos.y / IMDRAG.grid );

		absposX = ( ( divx < 0 ) ? ( divx + 1 ) : divx ) * IMDRAG.grid;
		absposY = ( ( divy < 0 ) ? ( divy + 1 ) : divy ) * IMDRAG.grid;

		IMDRAG.d.style.left = absposX - IMDRAG.origpos.x + IMDRAG.dx + "px";
		IMDRAG.d.style.top = absposY - IMDRAG.origpos.y + IMDRAG.dy + "px";

		IMDRAG.d.style.zIndex = IMDRAG.origzx;
	},

	moveObj: function( objid, absX, absY ) {
		var delem = getelementbyid( objid );

		var curpos = IMDRAG.getAbsolutePos( delem );
		var divx = parseInt( absX / IMDRAG.grid );
		var divy = parseInt( absY / IMDRAG.grid );

		var relPosX = parseInt( delem.style.left + 0 );
		var relPosY = parseInt( delem.style.top + 0 );

		absposX = ( ( divx < 0 ) ? ( divx + 1 ) : divx ) * IMDRAG.grid;
		absposY = ( ( divy < 0 ) ? ( divy + 1 ) : divy ) * IMDRAG.grid;

		delem.style.left = absposX - curpos.x + relPosX + "px";
		delem.style.top = absposY - curpos.y + relPosY + "px";
	}
}


function getObjectContent( objid, url ) {
	var rsp = IMgetContent( url );
	var dobj = getelementbyid( objid );

	dobj.innerHTML = rsp.text;
	if ( rsp.code != 0 ) {
		dobj.style.color = "red";
	}
}

function clearObjectContent( objid ) {
	var dobj = getelementbyid( objid );

	dobj.innerHTML = "";
}


function toggleObj( name ) {
	var trobj = getelementbyid( 'tr_' + name );

<%
	if ( is.bIsMSIE ) {
		out.println( "  if ( trobj.style.display == \"none\" ) { " );
		out.println( "      trobj.style.display = \"inline\";" );
		out.println( "  }" );
		out.println( "  else {" );
		out.println( "      trobj.style.display = \"none\";" );
		out.println( "  }" );
	}
	else {
		out.println( "  if ( trobj.style.visibility == \"collapse\" ) { " );
		out.println( "      trobj.style.visibility = \"visible\";" );
		out.println( "  }" );
		out.println( "  else {" );
		out.println( "      trobj.style.visibility = \"collapse\";" );
		out.println( "  }" );
	}
%>
}


function toggle( name, url ) {
	var trobj = getelementbyid( 'tr_' + name );

<%
	if ( is.bIsMSIE ) {
		out.println( "  if ( trobj.style.display == \"none\" ) { " );
		out.println( "      trobj.style.display = \"inline\";" );
	}
	else {
		out.println( "  if ( trobj.style.visibility == \"collapse\" ) { " );
		out.println( "      trobj.style.visibility = \"visible\";" );
	}
%>

		getObjectContent( "div_" + name, url );
	}
	else {
<%
		if ( is.bIsMSIE ) {
			out.println( "        trobj.style.display = \"none\";" );
		}
		else {
			out.println( "        trobj.style.visibility = \"collapse\";" );
		}
%>
		clearObjectContent( "div_" + name );
	}
}


function doSubmit( form, oper ) {
	form.cOp.value = oper;
	form.submit();
}

</script>



</HEAD>
<BODY>
<%

	if ( "references".equals( mode ) ) {
		printReferences( is, study );
//		out.println( "<script language=\"javascript\">" );
//		out.println( "  IMDRAG.moveObj( 'rc_studydb_obj', 25, 25 );" );
//		out.println( "  IMDRAG.moveObj( 'rc_objectfile_obj', 400, 25 );" );
//		out.println( "  IMDRAG.moveObj( 'rc_studydir_obj', 25, 175 );" );
//		out.println( "</script>" );
	}
	else if ( "tasks".equals( mode ) ) {
		out.println( "<h3>" + LocalizedMessage.getSimpleMessage( "tabTasks" ).toUpperCase() + "</h3>" );
	}
	else if ( "integrity".equals( mode ) ) {
		printIntegrityTable( is, study );
	}
	else {
		printStudyDirs( is, study );
		printStudyDB( is.out, study );
		printStoreState( is.out, study );
		
		out.println( "<script language=\"javascript\">" );
		out.println( "  IMDRAG.moveObj( 'studydirs_obj', 25, 25 );" );
		out.println( "  IMDRAG.moveObj( 'studytable_obj', 25, 175 );" );
		out.println( "  IMDRAG.moveObj( 'storestate_obj', 400, 175 );" );
		out.println( "</script>" );
	}

%></BODY></html>
--%>