#!/bin/sh

. ~/etc/setenv.sh

COLID=""
OPER=""
FILENAME=""
PEXCEPT=""
PDIRECTION=""
EXCLUDE_DBONLY=""


while getopts 'c:N:f:x:d:n:' OPT; do
	case $OPT in
		c) COLID="$OPTARG" ;;
		N) OPER="$OPTARG" ;;		
		f) FILENAME="$OPTARG" ;;
		x) PEXCEPT="-x \"$OPTARG\"" ;;
		d) PDIRECTION="-d \"$OPTARG\"" ;;
		n) EXCLUDE_DBONLY="-n" ;;
	esac
done

$CURL_HOME/bin/curl -s "http://127.0.0.1/cases/registerCalc.jsp?cColid=$COLID&cOper=$OPER"

# this will ensure recursion
$TASKD_HOME/createtaskfileapp -p "PROLIFERATE" -t "sh" -c "$DOTCOM_HOME/proliferate.sh -f \"$FILENAME\" $EXCLUDE_DBONLY $PDIRECTION $PEXCEPT -r \"$CASES_HOME/registercalc.sh\" -a -c -a \"$COLID\" -a -N -a \"$OPER\""  
#$DOTCOM_HOME/applystore.sh -f $FILENAME $PEXCEPT $PDIRECTION $EXCLUDE_DBONLY
 