<%@
	page errorPage="../main/exceptionHandler.jsp"

%><% throw new Exception("Unimplemented JSP");%>
<%--<%@
	page import="imagemed.imsession.*, imagemed.jsputil.*, imagemed.util.*, java.text.Format"

%><%@
	page errorPage ="../main/exceptionHandler.jsp"

%><%-- Input Parameters -- %><%

	IMSession is = new IMSession(request, response, out); 
	String parDevice    = request.getParameter("cDevice");

	is.bRegNotNeeded = true; // no login in a popup window
	if (!is.regOK()) {
		return;
	}

%>
<HTML>
<HEAD><TITLE><%= LocalizedMessage.getSimpleMessage( "GENERIC_SELECT" ) %></TITLE>
<%
	com.erad.pacs.app.broker.table.internals.TableImpl.printCommonScript(is);
	imagemed.http.tabs.TabBean.writeStyleOnly(is);

%>

	<SCRIPT language="JavaScript">
		var oOpenerDevice;
		var oOpenerAll;
		var oDevice;
		var oAll;

		/*
		 * Checks if a select object contains a specific options
		 * (there is an option in the select list having the same value as the argument option)
		 *
		 * oSelect - select object to be checked for the option
		 * oObject - select option to be searched for
		 */
		function contains(oSelect, oOption) {
			for (var i = 0; i < oSelect.options.length; i++) {
				if (oSelect.options[i].value == oOption.value)
					return true;
			}

			return false;
		}

		/*
		 * Comparator function for sorting select options by display text
		 *
		 * a, b - Option objects of a select list to be sorted
		 */
		function compareOptionsByText(a, b) {
			if (a.text.toLowerCase() == b.text.toLowerCase())
				return 0;
			return a.text.toLowerCase() < b.text.toLowerCase() ? -1 : 1;
		}

		/*
		 * Comparator function for sorting select options by display text
		 *
		 * a, b - Option objects of a select list to be sorted
		 */
		function compareOptionsByValue(a, b) {
			if (a.value == b.value)
				return 0;
			return a.value < b.value ? -1 : 1;
		}

		/*
		 * Sorts the options of a select list by option display text
		 * 
		 * oSelect  select list
		 */
		function sortOptionsByText(oSelect) {
			if (oSelect.options.length <= 0)
				return;

			var optionArray = new Array(oSelect.options.length);
			var i;
			for (i = 0; i < oSelect.options.length; i++) {
				optionArray[i] = new Option(oSelect.options[i].text, oSelect.options[i].value);
			}

			optionArray.sort(compareOptionsByText);
			for (i = 0; i < optionArray.length; i++) {
				oSelect.options[i] = optionArray[i];
			}
		}

		/*
		 * Moves selected options from one select object to another
		 *
		 * oFrom - source select object to move selected options from
		 * oTo   - destination select object the selected optins to be moved to
		 */
		function moveSelectedOptions(oFrom, oTo) {
			var selectedIndex; /* selected Index */
			for (var i = 0; i < oFrom.options.length; i++) {
				if (!oFrom.options[i].selected) {
					continue;
				}

				if (!contains(oTo, oFrom.options[i])) {
					oTo.options[oTo.length] = new Option(oFrom.options[i].text, oFrom.options[i].value);
				}

				oFrom.options[i] = null;
				i--; /* make the loop go through them all */
			}

			sortOptionsByText(oTo);
		}

		/*
		 * Fills the select list from the select list on the opener page
		 *
		 * oTarget - select list to be filled
		 * oSource - source select list on the opener page   
		 */
		function fillSelect(oTarget, oSource) {
			for (var i = 0; i < oSource.options.length; i++) {
				if (oSource.options[i].value == '')
					oTarget.options[i] = new Option(oSource.options[i].text, oSource.options[i].text);
				else
					oTarget.options[i] = new Option(oSource.options[i].text, oSource.options[i].value);
			}
		}

		/*
		 * Select all options in a select list
		 *
		 * oSelect - select object
		 */
		function selectAll(oSelect) {
			for (var i = 0; i < oSelect.options.length; i++) {
				oSelect.options[i].selected = true;
			}
		}

		/*
		 * Deselect all options in a select list
		 *
		 * oSelect - select object
		 */
		function deselectAll(oSelect) {
			for (var i = 0; i < oSelect.options.length; i++) {
				oSelect.options[i].selected = false;
			}
		}

		/*
		 * Initialize the select lists based on the content of the opener page
		 */
		function initSelects() {
			oOpenerDevice = opener.document.dcmForm.deviceSOP;
			oOpenerAll =  opener.document.dcmForm.systemSOP;
			oDevice = self.document.sopClassForm.deviceSOP;
			oAll = self.document.sopClassForm.allSOP;

			fillSelect(oDevice, oOpenerDevice);
			fillSelect(oAll, oOpenerAll);

			for (var i = 0; i < oAll.options.length; i++) {
				if (contains(oDevice, oAll.options[i])) {
					oAll.options[i] = null;
					i--;
				}
			}

			sortOptionsByText(oDevice);
			sortOptionsByText(oAll);
		}

		/*
		 * Applies changes by copying the content of the device select list back to the opener window 
		 */
		function applyChanges() {
			opener.copySelect(oOpenerDevice, oDevice);
			window.close();
		}

	</SCRIPT>
</HEAD>
<BODY>
 <CENTER>
 <FORM name=sopClassForm>
 <TABLE border=1 cellpadding=0 cellspacing=0 width="100%"><TR class=BgShadow><TD>
  <TABLE border=0 cellpadding=2 cellspacing=2 width="100%">
  <COL width="48%">
  <COL width="4%">
  <COL width="48%">
  <TR>
   <TD align="center"><FONT size=+1><B><%= LocalizedMessage.getCompoundMessage( "IMADMIN_SELECTSOPCLASSES_STORAGE_SUPPORTED", new Format [] { null }, new Object[] { parDevice }, true) %></TD>
   <TD>&nbsp;</TD>
   <TD align="center"><FONT size=+1><B><%= LocalizedMessage.getSimpleMessage( "IMADMIN_SELECTSOPCLASSES_AVAILABLE_STORAGE" ) %></TD>
  </tr>
  <TR>
   <TD align="center"><select name="deviceSOP" multiple size=20>
    </select>
    <DIV>
    <A href="javascript:selectAll(self.document.sopClassForm.deviceSOP)"><%=Button.getJsImage2(is, "/cases/art/selectAllButton.png", 24, 24, "")%></A
    >&nbsp;&nbsp;<A href="javascript:deselectAll(self.document.sopClassForm.deviceSOP)"><%=Button.getJsImage2(is, "/cases/art/selectNoneButton.png", 24, 24, "")%></A>
    </DIV>
   </TD>
   <TD align="center" valign="center">
    <A href="javascript:moveSelectedOptions(self.document.sopClassForm.allSOP, self.document.sopClassForm.deviceSOP)"><%=Button.getJsImage(is, "left", 18, 18, "")%></A>
    <BR>
    <BR>
    <BR>
    <A href="javascript:moveSelectedOptions(self.document.sopClassForm.deviceSOP, self.document.sopClassForm.allSOP)"><%=Button.getJsImage(is, "right", 18, 18, "")%></A>
    <BR>
   </TD>
   <TD align="center"><select name="allSOP" multiple size=20>
    </select>
    <DIV>
    <A href="javascript:selectAll(self.document.sopClassForm.allSOP)"><%=Button.getJsImage2(is, "/cases/art/selectAllButton.png", 24, 24, "")%></A
    >&nbsp;&nbsp;<A href="javascript:deselectAll(self.document.sopClassForm.allSOP)"><%=Button.getJsImage2(is, "/cases/art/selectNoneButton.png", 24, 24, "")%></A>
    </DIV>
   </TD>
    <SCRIPT language="JavaScript">
     initSelects();
    </SCRIPT>
  </TR>
  </TABLE></TD>
 </TR>
 </TABLE><TABLE border=1 cellpadding=0 cellspacing=0 width="100%">
 <TR>
  <TD class=BgShadow align="right" height=18>
  <BR>
  <IMG SRC="/cases/art/spacer.gif" width=5 height=25>
  &nbsp;&nbsp;
  <A href="javascript:applyChanges()"><%= JSHelper.getJsLocalizedButton( "BUTTON_APPLY", "BUTTON_NULL", false )%></a>
  &nbsp;&nbsp;
  <A href="javascript:window.close()"><%=JSHelper.getJsLocalizedButton( "BUTTON_CANCEL", "BUTTON_NULL", false )%></a>
  &nbsp;&nbsp;
  </TD>
 </TR>
 <TR>
  <TD class=FieldBlock></TD>
 </TR>
 </TABLE>
 </FORM>
</CENTER>
</BODY>
</HTML>
--%>